//package exp;
import bham.cs.fsc.ui.*;
//import gp.*;
import bham.cs.fsc.exp.FileIODialog;

import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Button;
import java.awt.Event;
import java.awt.Label;
import java.awt.Component;
import java.awt.Color;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.FileDialog;
import java.awt.Font;
import java.io.File;

/**
* 
* This is the modal dialog for loading a population and seed from a file when DGPClient is run as an application.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class LoadFileFrame extends Frame {
     
	private Button defaultButton;
	private Button cancelButton;
        private Button dialogButton;
        //private TextArea fileLoadText;
        //private Label status;

        //DGPClient dgpClient;

        String popFileName;
        File popFile;

        static final String defaultPopFile = "GP.pop";

         String loadFileMsg = "If this is the first time you are running this application, click on the CANCEL button and ignore this message.\n\nIf you have prematurely stopped a previous run and saved its GP population and seed into a file, please load the population and seed from the file and continue the run.\n\nClick on the LOAD FROM DEFAULT FILE' button if you have saved the population and seed into the default file " + defaultPopFile + ".\n\nIf you have saved the population and seed into a different file, click on the 'SPECIFY FILE TO LOAD' button. This will bring up another dialog for you to choose your file.\n\nIf, however, you do not wish to continue the run, please click on the 'CANCEL' button to start the run with a new population and seed.";

	
	public LoadFileFrame() {
	  //super ("Restore File");
	  setTitle("Restore File");
	  //super(parent, new Rectangle(8, 8, 290, 110)

		//setResizable(false);
		setResizable(true);
		
		//this.dgpClient = dgpClient;
		
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		buttonPanel.setFont(new Font("Courier",Font.BOLD,11));
		defaultButton = new Button("Load from default file");
		buttonPanel.add("Tall Wide", defaultButton);
		dialogButton = new Button("Specify file");
		buttonPanel.add("Tall Wide", dialogButton);
		//buttonPanel.add("Tall Wide", new Panel());	// just as a spacer
		cancelButton = new Button("Cancel");
		buttonPanel.add("Tall Wide", cancelButton);

		Panel textPanel = new Panel();
		//textPanel.setLayout(new BorderLayout());
		textPanel.setLayout(new FlowLayout()); //default layout for panels
		textPanel.setFont(new Font("Courier",Font.PLAIN,11));
		//Label fileLoadText = new Label(loadFileMsg,Label.CENTER);
		TextArea fileLoadText = new TextArea(loadFileMsg,22,75,TextArea.SCROLLBARS_NONE);
		//fileLoadText.setFont("Courier",Font.Plain,11);
		fileLoadText.setEditable(false);
		//textPanel.add("Center", fileLoadText);
		textPanel.add(fileLoadText);

		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", textPanel);
		add("Bottom Wide", buttonPanel);	
	}

	/**
	* Is called whenever the user clicks a command button.
	*/
	public boolean action(Event evt, Object what) {
		if (evt.target == defaultButton) {
		  popFile = new File(defaultPopFile);
		  if (popFile.exists()) {
		    //DGPClient.popFileName = defaultPopFile;
		    DGP.popFileName = defaultPopFile;
		    System.out.println("'Load from default file' button pressed. popFileName set to " + defaultPopFile);
		    //DGPClient.m.finished();
		    DGP.m.finished();
		    dispose();
		  } else {
		    FileIODialog n = new FileIODialog(this, "File '" + defaultPopFile + "' is NOT found.\nPlease check if it is in another directory or provide another file name.", "File Not Found");
		    n.show();
		    n.pack();
		  }
	          return true;
		}
		
		if (evt.target == dialogButton) {
		  //Create a file dialog to query the user for a filename.
		  FileDialog f = new FileDialog(this, "Load population from file", FileDialog.LOAD);
		  //f.setSize(5000, 7500);
		  //System.out.println("file dialog size : " + f.getSize().width + "," + f.getSize().height);
		  f.show();
		  f.pack();
		  
		  String popFileDir = f.getDirectory();
		  System.out.println("Dir to load file from : " + popFileDir);
		  String popFileNm = f.getFile();
		  System.out.println("File to load file from : " + popFileNm);
		  //popFileName = f.getFile();
		  //if (popFileName != null) {

		  if ((popFileDir == null) || (popFileNm == null)) {
		    //DGPClient.popFileName = null;
		    //DGPClient.m.finished();
		    DGP.popFileName = null;
		    DGP.m.finished();
		    dispose();
		  }
		  else 
		    if (popFileDir.trim() == "./") {
		      FileIODialog n = new FileIODialog(this,"File name './' is NOT valid.\nPlease check if it is in another directory or provide another file name. ", "Invalid File Name");
		      n.show();
		      n.pack();
		    }
		    else {
		      //if (((popFileDir != null) && (popFileDir.trim() !="./")) && ((popFileNm != null) && (popFileNm.trim() != ""))) {
			popFileName = popFileDir + popFileNm;
			System.out.println("popFileName to load from : " + popFileName);
			popFile = new File(popFileName);
			if (popFile.exists()) {
			  //DGPClient.popFileName = popFileName;
			  DGP.popFileName = popFileName;
			  System.out.println("'Specify File' button pressed. popFileName set to " + DGP.popFileName);
			  //DGPClient.m.finished();
			  DGP.m.finished();
			  dispose();
			}
			else {
			  FileIODialog n = new FileIODialog(this,"File '" +popFileName + "' is NOT found.\nPlease check if it is in another directory or provide another file name.", "File Not Found");
			  n.show();
			  n.pack();
			}
		    }
		  /*
		  else 
		    if (popFileDir.trim() == "./") {
		      FileIODialog n = new FileIODialog(this,"File './' is NOT found.\nPlease check if it is in another directory or provide another file name. ", "File Not Found");
		      n.show();
		    }
		    else 
		      if ((popFileDir == null) && (popFileNm == null)) {
		      DGPClient.popFileName = null;
		      DGPClient.m.finished();
		      dispose();
		      }
		      */
		  return true;
		}

		if (evt.target == cancelButton) {
		  //DGPClient.popFileName = null;
		  DGP.popFileName = null;
		  System.out.println("'Cancel' button pressed. popFileName set to null");
		  //DGPClient.m.finished();
		  DGP.m.finished();
		  dispose();
		  return true;
		}
		return false;
	}

// The handleEvent() method receives all events generated within the frame
	// window. You can use this method to respond to window events. To respond
	// to events generated by menus, buttons, etc. or other controls in the
	// frame window but not managed by the applet, override the window's
	// action() method.
	//--------------------------------------------------------------------------
	public boolean handleEvent(Event evt)
	{
		switch (evt.id)
		{
			// Application shutdown (e.g. user chooses Close from the system menu).
			//------------------------------------------------------------------
			case Event.WINDOW_DESTROY:
				// TODO: Place additional clean up code here
				dispose();
				System.exit(0);
				return true;

			default:
				return super.handleEvent(evt);
		}			 
	}

}








