package bham.cs.fsc;

import java.io.*;
//import javax.servlet.*;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.zip.*;    
import java.util.Vector;
import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;

import bham.cs.fsc.gp.Individual;
import bham.cs.fsc.gp.Program;
import bham.cs.fsc.gp.Condition;

//import gp.*;


public class Pop25Servlet extends HttpServlet  {

  public static final String currentProblem = "SantaFe";

  Hashtable popTable;
  //PrintStream popLog;

  //String paramName;
  //Object paramValue;
  String fileName;

  PrintStream eventLog;

  String clientProbName;
  String clientIPAddr;
  String clientHostName;
  String clientProtocol;
  String clientID;
  Individual[] IndArray;
  int recvIndNum;
  public static Hashtable popPool;
  Vector clientVector;

  static RandomGen random;
  int popPoolClientIndex;
  Individual[] sendIndArray;
  StringBuffer sb;
  
  FileInputStream fis;
  GZIPInputStream gzis;
  ObjectInputStream in;

  FileOutputStream fos;
  GZIPOutputStream gzos;
  ObjectOutputStream out;

  String errorMsg = "";

  static final String servletLogDir = "/home/students/acs97/fsc/ServletLog/";
  static final String ServletName = "PopServlet";

  static final String eventLogFileName = servletLogDir + "Servlet.PopEventlog" ;

  /*
  static final String eventLogFileName = servletLogDir + "Servlet.PopEventlog" + "_" +
  DateFormat.getDateInstance(DateFormat.SHORT, Locale.CHINA).format(new Date()) + "_" + 
  DateFormat.getTimeInstance(DateFormat.SHORT, Locale.UK).format(new Date()) ;
  */
  
  static final String popPoolFileName = servletLogDir + "Servlet.PopPool";
  static final int maxClientVectorSize = 5;

  public static final int defaultSEED = 12345;
  static final int randomSeed = defaultSEED ;


  public void init(ServletConfig c) throws ServletException {
    
    super.init(c);
    
    //Create random number generator
    random = new RandomGen(randomSeed + Seed24Servlet.count);
    random.setSeed(randomSeed + Seed24Servlet.count);  
    
    String fileDateTime =  DateFormat.getDateInstance(DateFormat.SHORT, Locale.CHINA).format(new Date()) + "_" + 
      DateFormat.getTimeInstance(DateFormat.SHORT, Locale.UK).format(new Date()) ;

    //Open popEventLogFile
    try {
      eventLog = new PrintStream(new FileOutputStream(eventLogFileName + "_" + fileDateTime));
    } 
    catch (IOException e) {}
      
    eventLog.println(getLogHeading(ServletName) + "PopServlet initialised.");


    //Open popPool File
    if (new File(popPoolFileName).exists()) {
      try {
	fis = new FileInputStream(popPoolFileName); //Read from file
	gzis = new GZIPInputStream(fis); //Uncompress
	in = new ObjectInputStream(gzis); //Read objects
	//*in = new ObjectInputStream(fis); //Read objects
	
	eventLog.println(getLogHeading(ServletName) + "Object input stream successfully created for pop pool file");
      }
      catch (IOException e) {eventLog.println(getLogHeading(ServletName) + "IOException when opening input stream for popPool file : " + e); }
      //catch (ClassNotFoundException c) {System.out.println(c); }    
    }
    else {
      in = null;
      eventLog.println(getLogHeading(ServletName) + "pop Pool file does not exist. Object input stream not created for the file.");
    }
    
    
    try {
      //Create the necessary input streams to load the population
      //*FileInputStream fis = new FileInputStream(popPoolFileName); //Read from file
      //*GZIPInputStream gzis = new GZIPInputStream(fis); //Uncompress
      //*ObjectInputStream in = new ObjectInputStream(gzis); //Read objects
      //Read in an object. It should be an array of Individuals
      
      if (in != null) { 
	
	popPool = (Hashtable)in.readObject();
	in.close();
	eventLog.println(getLogHeading(ServletName) + "popPool object successfully read from popPool file"); 
      }
      else {
	eventLog.println(getLogHeading(ServletName) + "pop pool file does not exist yet.");
	popPool = new Hashtable();	
      }
    }	
    catch (IOException e) { eventLog.println(getLogHeading(ServletName) + "IOException when readingObj : " +  e); }
    catch (ClassNotFoundException f) {eventLog.println(getLogHeading(ServletName) + "ClassNotFoundException when readingObj : " + f); }	
	
  }
  

  String getLogHeading(String id) {
    return DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT, Locale.UK).format(new Date()) + " : " + id + " : ";
  }

  
  public void doPost(HttpServletRequest req,
		    HttpServletResponse res)
    throws IOException, OptionalDataException {

      eventLog.println("****************************************");
      //eventLog.println(getLogHeading() + "Inside doPost()");

      //open and read object input stream
      ObjectInputStream objIn = new ObjectInputStream(new GZIPInputStream(req.getInputStream()));
      
      //eventLog.println(getLogHeading() + "ObjectInputStream successfully created.");
     
      if (objIn == null) {
	eventLog.println(getLogHeading(ServletName) + "object input stream is null !");
      }

      try {
	popTable = (Hashtable)objIn.readObject();
	eventLog.println(getLogHeading(ServletName) + "object read successfully.");
      }
      catch (ClassNotFoundException e) {eventLog.println(getLogHeading(ServletName) + "ClassNotFoundException in objIn.readObject() " + e);}
  
      //extract data received from object input stream
      clientID = (String)popTable.get("ClientID");
      IndArray = (Individual[])popTable.get("IndArray");
      recvIndNum = ((Integer)popTable.get("RecvIndNum")).intValue();

      // read in the servlet's parameters 
      eventLog.println(getLogHeading(clientID) + "clientID : " + clientID);
      String clientQueryString = req.getQueryString();
      eventLog.println(getLogHeading(clientID) + "clientQuery String : " + clientQueryString);
      clientProbName = clientQueryString.substring(clientQueryString.indexOf("=") + 1);
      eventLog.println(getLogHeading(clientID) + "clientProbName : " + clientProbName);
      clientIPAddr = req.getRemoteAddr();
      eventLog.println(getLogHeading(clientID) + "clientIPAddr : " + clientIPAddr);
      clientHostName = req.getRemoteHost();
      eventLog.println(getLogHeading(clientID) + "clientHostName : " + clientHostName);
      clientProtocol = req.getProtocol();
      eventLog.println(getLogHeading(clientID) + "clientProtocol : " + clientProtocol);
      
      //form client file name and read its contents into a StringBuffer
      BufferedReader d = null;
      String line = "";
      sb = new StringBuffer();
      boolean fileFound = true;
      
      if ((clientProbName != null) &&(clientProbName.trim()).equals(currentProblem.trim())) {
	eventLog.println(getLogHeading(clientID) + "clientProbName not null and equals to " + currentProblem);

	fileName = servletLogDir + currentProblem + "." +  clientID + ".params";
	  eventLog.println(getLogHeading(clientID) + "Client's file name : " + fileName);	    
	  
	  //fileName = "/home/students/acs97/fsc/" + currentProblem + "." +  clientIPAddr + ".params"; 
	  try {
	    d = new BufferedReader(new FileReader(fileName));
	    eventLog.println(getLogHeading(clientID) + "Reading contents from client file");
	  } 
	  catch(FileNotFoundException e) {
	    //file should have been created when client requests for seed. If client failed to receive seed, it will use the default seed 12345 and will run standalone without exchange of individuals.
	    eventLog.println(getLogHeading(clientID) + "file not found !!!");
	    fileFound = false;
	  }
      
	  if (fileFound) {
	    boolean cont = true ;
	    while (cont == true) {
	      try {
		line = (d.readLine()) ;
	      } catch(IOException e) {
		eventLog.println(getLogHeading(clientID) + "readLine for Client file error: " + e);
		cont = false ;
	      }
	      if (line != null) {
		//eventLog.println(getLogHeading(clientID) + line);
		sb.append(line + "\n");	    
	      } 
	      else {
		//eventLog.println(getLogHeading(clientID) + "line is null");
		cont = false;
	      }
	    }
	  }
	  
	  //apend info on number of individuals received and sent into String Buffer
	  if (IndArray != null) {
	    eventLog.println(getLogHeading(clientID) + "Received " + IndArray.length + " individuals from client.\n"); 
	    sb.append(getLogHeading(ServletName) + "Received " + IndArray.length + " individuals from client.\n");
	  }
	  else {
	    eventLog.println(getLogHeading(clientID) + "Null individual array received from client or error in receiving object from client.\n"); 
	    sb.append(getLogHeading(ServletName) + "Null individual array received from client or error in receiving object from client.\n");
	  }
	    

	  //**Only write sb.toString() to client file if fileFound is true
	if (clientIPAddr != null) {
	  eventLog.println(getLogHeading(clientID) + "clientIPAddr not null");
	}
	else {
	  eventLog.println(getLogHeading(clientID) + "client IP address is null !!!");
	  //sb.append(getLogHeading() + "client IP address is null !!!");
	}
      }
      else {
	errorMsg = "NoSuchProblem";
	eventLog.println(getLogHeading(clientID) + "set errorMsg to 'NoSuchProblem'.");
	//sb.append(getLogHeading() + "set errorMsg to 'NoSuchProblem'.");
      }


      //open popPoolFile containing the hashtable for the individuals pool
      //if (new File(popPoolFileName).exists()) {


      //Create input stream for PopPool file
      /*
      if (new File(popPoolFileName).exists()) {
	try {
	  fis = new FileInputStream(popPoolFileName); //Read from file
	  gzis = new GZIPInputStream(fis); //Uncompress
	  in = new ObjectInputStream(gzis); //Read objects
	  //*in = new ObjectInputStream(fis); //Read objects
	  
	  eventLog.println(getLogHeading(clientID) + "Object input stream successfully created for pop pool file");
	}
	catch (IOException e) {eventLog.println(getLogHeading(clientID) + "IOException when opening input stream for popPool file : " + e); }
	//catch (ClassNotFoundException c) {System.out.println(c); }    
      }
      else {
	in = null;
	eventLog.println(getLogHeading(clientID) + "pop Pool file does not exist. Object input stream not created for the file.");
      }
      */
      /*
      try {
	//Create the necessary input streams to load the population
	//*FileInputStream fis = new FileInputStream(popPoolFileName); //Read from file
	//*GZIPInputStream gzis = new GZIPInputStream(fis); //Uncompress
	//*ObjectInputStream in = new ObjectInputStream(gzis); //Read objects
	//Read in an object. It should be an array of Individuals
	
	if (in != null) { 
	  
	    popPool = (Hashtable)in.readObject();
	    in.close();
	    eventLog.println(getLogHeading(clientID) + "popPool object successfully read from popPool file");
	    */

	    if (popPool != null) {
	      eventLog.println(getLogHeading(clientID) + "popPool read from file is not null.");
	      if (clientIDExists()) {
		eventLog.println(getLogHeading(clientID) + "clientID exists in the popPool");
		addIndToVector((Vector)popPool.get(clientID));
		eventLog.println(getLogHeading(clientID) + "received individual(s) added to vector for client " + clientID);
	      }
	      else {
		eventLog.println(getLogHeading(clientID) + "clientID does not exist in the popPool");
		addIndToNewVector();
		eventLog.println(getLogHeading(clientID) + "received individual(s) added to a new vector");
	      }
	    } 
	    /*
	  }
	  else {
	    eventLog.println(getLogHeading(clientID) + "pop pool file does not exist yet.");
	    popPool = new Hashtable();
	    addIndToNewVector();
	    eventLog.println(getLogHeading(clientID) + "new Hashtable created for popPool and individual(s) received added to new Vector.");
	  }
	}	
	catch (IOException e) { eventLog.println(getLogHeading(clientID) + "IOException when readingObj : " +  e); }
	catch (ClassNotFoundException c) {eventLog.println(getLogHeading(clientID) + "ClassNotFoundException when readingObj : " + c); }
	*/	
      /*
	}
	else {
	eventLog.println(getLogHeading() + "popPoolFile does not exist.");
	popPool = new Hashtable();
	addIndToNewVector();
	}
      */
      
      eventLog.println(getLogHeading(clientID) + "Selecting individuals to send.");
      Individual[] sendIndArray = null;
      //Select individuals to sent back to applet

      eventLog.println(getLogHeading(clientID) + "Individuals to receive : " + recvIndNum);
      eventLog.println(getLogHeading(clientID) + "Number of different Client IDs in popPool : " + popPool.size());

      if ((! errorMsg.equals("NoSuchProblem")) && (recvIndNum > 0)) {
	Vector sendIndVector = new Vector();
	eventLog.println(getLogHeading(clientID) + "problem solved matches. new send Vector object created.");
	//Individual[] sendIndArray;
	
	//***May be it would be better to put all the keys(clientIDs) into a vector, so that it is easier to select the individual to send.
	
	if  (recvIndNum < popPool.size()) {

	  //eventLog.println(getLogHeading(clientID) + "individuals to receive is lesser than the number of clientIDs in the popPool");
	  int s = random.nextInt(99999);
	  RandomGen r = new RandomGen(s);
	  r.setSeed(s);  
	  
	  eventLog.println(getLogHeading(clientID) + "Random number generator created. Seed used is " + s);

	  sendIndVector = getIndvsFromSelectedClients(r);

	  eventLog.println(getLogHeading(clientID) + "clients selected randomly and sendIndVector created.");
	}
	else {
	  sendIndVector = getIndvsFromAllClients();
	  
	  eventLog.println(getLogHeading(clientID) + "all clients' individuals selected and sendIndVector created.");
	    }
	
	eventLog.println(getLogHeading(clientID) + "sendIndVector created with " + sendIndVector.size() + " members.");
	//sb.append(getLogHeading() + "sendIndVector created with " + sendIndVector.size() + " members.");
	
	
	//copying sendIndVector into sendIndArray
	if ((! sendIndVector.isEmpty()) && (sendIndVector != null)) {
	  eventLog.println(getLogHeading(clientID) + "sendIndVector is not empty or null");
	  sendIndArray = new Individual[sendIndVector.size()];
	  sendIndVector.copyInto(sendIndArray);
	  eventLog.println(getLogHeading(clientID) + "sendIndVector converted into an array and sendIndArray formed.");
	  //sb.append(getLogHeading() + "sendIndArray formed.");
	}
	else {
	  sendIndArray = null;
	  eventLog.println(getLogHeading(clientID) + "sendIndArray is empty --- set to null");
	  //sb.append(getLogHeading() + "sendIndArray is empty --- set to null");
	} 
      }
      
      //sending indv array back to applet using object output stream.
      //*Hashtable sendObj = new Hashtable();
      //*sendObj.put("ErrorMsg", errorMsg);
      //*sendObj.put("SendIndArray", sendIndArray);
	    
      res.setContentType("application/octet-stream");
      
      ObjectOutputStream objOut = new ObjectOutputStream(new GZIPOutputStream(res.getOutputStream()));
      eventLog.println(getLogHeading(clientID) + "ObjectOutputStream created.");
      
      objOut.writeObject(sendIndArray);
      //*objOut.writeObject(sendObj);
      eventLog.println(getLogHeading(clientID) + "sendObj Hashtable written to output stream.");
      //sb.append(getLogHeading() + "sendIndArray written to output stream.");

      objOut.flush();
      objOut.close();  
      eventLog.println(getLogHeading(clientID) + "object output stream flushed and closed.");      
      
      if (sendIndArray != null) {
	sb.append(getLogHeading(ServletName) + "An array of " + sendIndArray.length + " individuals have been successfully sent to the client.\n");
      }
      else {
	sb.append(getLogHeading(ServletName) + "A null array has been sent to the client -- either the client has indicated not to receive any individuals or the servlet could not find any individual that has not been sent to the client before.\n");
      }

      //write client log into file and close the stream.
      //if (fileFound) {
	String clientLogString = sb.toString();
	eventLog.println(getLogHeading(clientID) + "string buffer for client converted to string");
	PrintStream clientLog = new PrintStream(new FileOutputStream(fileName));
	eventLog.println(getLogHeading(clientID) + "client file " + fileName + " found and opened.");
	clientLog.println(clientLogString);
	eventLog.println(getLogHeading(clientID) + "buffer string written to client file");
	clientLog.flush();
	clientLog.close();
	eventLog.println(getLogHeading(clientID) + "client file flushed and closed");
	//}


    //write popPool into popPoolFile and close output stream
	synchronized (popPool) {
    try {
      if (! popPool.isEmpty()) {
	//Create output stream for PopPool file
	try {
	  fos = new FileOutputStream(popPoolFileName); //Save to file
	  gzos = new GZIPOutputStream(fos); //Compress
	  out = new ObjectOutputStream(gzos); //Save objects
	  //*out = new ObjectOutputStream(fos);
	    
	  eventLog.println(getLogHeading(clientID) + "Object output stream successfully created for pop pool file");
	}
	catch (IOException e) {eventLog.println(getLogHeading(clientID) + "IOException when opening output stream for popPool file : " + e);}
      
	out.writeObject(popPool);
	eventLog.println(getLogHeading(clientID) + "popPool Hashtable object written to the output stream for popPool file ");
	
	out.flush();
	out.close();
	eventLog.println(getLogHeading(clientID) + "output stream for popPool file flushed and closed");
	  
      }
      else {
	eventLog.println(getLogHeading(clientID) + "popPool hashtable object is empty. popPool is not written to popPool file.");
      }
      
    }
    catch (IOException e) { eventLog.println(getLogHeading(clientID) + "IOException when closing output output stream for popPool file : " + e); }
    	
	}
  }

  
  public void destroy() {

    //write popPool into popPoolFile and close output stream
    try {
      if (! popPool.isEmpty()) {
	//Create output stream for PopPool file
	try {
	  fos = new FileOutputStream(popPoolFileName); //Save to file
	  gzos = new GZIPOutputStream(fos); //Compress
	  out = new ObjectOutputStream(gzos); //Save objects
	  //*out = new ObjectOutputStream(fos);
	    
	  eventLog.println(getLogHeading(clientID) + "Object output stream successfully created for pop pool file");
	}
	catch (IOException e) {eventLog.println(getLogHeading(clientID) + "IOException when opening output stream for popPool file : " + e);}
      
	out.writeObject(popPool);
	eventLog.println(getLogHeading(clientID) + "popPool Hashtable object written to the output stream for popPool file ");
	
	out.flush();
	out.close();
	eventLog.println(getLogHeading(clientID) + "output stream for popPool file flushed and closed");
	  
      }
      else {
	eventLog.println(getLogHeading(clientID) + "popPool hashtable object is empty. popPool is not written to popPool file.");
      }
      
    }
    catch (IOException e) { eventLog.println(getLogHeading(clientID) + "IOException when closing output output stream for popPool file : " + e); }
    

    //close eventLog stream
      eventLog.flush();
      eventLog.close();
      //eventLog.println(getLogHeading() + "eventLog output stream flushed and closed"); //will not appear as log is closed

  }

  
  Vector getIndvsFromSelectedClients(RandomGen r) {    
    int j = 0;
    int k = 0;
    int index;
    Enumeration e;
    Vector indVec = new Vector(); 
    Individual ind = null;

    eventLog.println(getLogHeading(clientID) + "inside getIndvsFromSelectedClients()");

    while ((j < recvIndNum) && (k < popPool.size())) {
      index = r.nextInt(popPool.size() - 1);
      eventLog.println(getLogHeading(clientID) + "index of popPool generated by randomiser is : " + index);
      
      e = popPool.keys();
      for (int m=0; m < index; m++) {
	e.nextElement(); //advancing the entries in the hashtable //***hashtable entry order may be diff each time ?? change to use vector instead ??
	//eventLog.println(getLogHeading(clientID) + "advancing the entries in the popPool hashtable to the vector corresponding to the index");

      }
      ind = getIndvFromAClient((Vector)popPool.get(e.nextElement()));
      eventLog.println(getLogHeading(clientID) + "individual selected and obtained from a client with the index in the popPool"); 
		       
      if (ind != null) {
	indVec.addElement(ind);
	eventLog.println(getLogHeading(clientID) + "individual selected added into the individual vector");

	j++;
	eventLog.println(getLogHeading(clientID) + "no. of individuals selected is " + j);
      }
      k++;
      eventLog.println(getLogHeading(clientID) + "no. of client vectors accessed in the popTable : " + k);
    }
    return indVec;
  }


  Vector getIndvsFromAllClients() {
   
    eventLog.println(getLogHeading(clientID) + "inside getIndvsFromAllClients()");

    Vector indVec = new Vector();
    Enumeration e = popPool.keys();
    Individual ind;
    while (e.hasMoreElements()) {
      ind = getIndvFromAClient((Vector)popPool.get(e.nextElement()));
      if (ind != null) {
	indVec.addElement(ind);

	eventLog.println(getLogHeading(clientID) + "individual obtained from a client is not null and added into individual vector");
      }
    }
    return indVec;
  }
      
  
  Individual getIndvFromAClient(Vector indVector) {
    Enumeration e1;
    Enumeration e2;
    Individual indv = null;
    boolean indvFound = false; 
    int j = indVector.size() - 1;
    
    eventLog.println(getLogHeading(clientID) + "inside getIndvFromAClient");

    while ((! indvFound) && (j >= 0)) { 
      Hashtable indTable = (Hashtable)(indVector.elementAt(j));
      eventLog.println(getLogHeading(clientID) + "obtained hashtable element at " + j + " in client indVector");

      e1 = indTable.keys(); //enumeration of indvStrings
      Hashtable accessTable = (Hashtable)indTable.get(e1.nextElement()); 
      eventLog.println(getLogHeading(clientID) + "obtained the accessTable for the element.");

      e2 = accessTable.keys(); //enumeration of indvs
      Individual ind = (Individual)e2.nextElement(); //only indv in table
      eventLog.println(getLogHeading(clientID) + "obtained the Individual object for the element.");

      Vector accessVec = (Vector)accessTable.get(ind); //vector of clientIDs which have received this individual
      eventLog.println(getLogHeading(clientID) + "obtained the access Vector associated with the element.");

      if (! accessVec.contains(clientID)) {
	eventLog.println(getLogHeading(clientID) + "Access vector does not contain this clientID " + clientID);
 
	accessVec.addElement(clientID);
	eventLog.println(getLogHeading(clientID) + "This clientID added to the access list of the element");

	indv = ind;
	indvFound = true;

	sb.append(getLogHeading(ServletName) + "Individual selected for export to client has a fitness of " + indv.hits + ".\n");

	eventLog.println(getLogHeading(clientID) + "indvFound set to true --- will exit from loop to search for individuals.");
      }
      else { 
	eventLog.println(getLogHeading(clientID) + "this individual has already been received by the client previously.");
	
	indv = null;
	eventLog.println(getLogHeading(clientID) + "Individual already been received !");
	//sb.append(getLogHeading() + "Individual already been received !");
      }
      j = j - 1;
      
    }
    return indv;
  }
  
  
  
  boolean clientIDExists() {
    if (popPool.containsKey(clientID)) {

    eventLog.println(getLogHeading(clientID) + "Client vector for " + clientID + " exists in popPool.");
    //sb.append(getLogHeading() + "Client vector for " + clientID + " exists in popPool.");

    return true;
    
    }
    
    eventLog.println(getLogHeading(clientID) + "Client vector for " + clientID + " does not exist in popPool.");
    return false;
  }

  
  void addIndToVector(Vector v) {
    Hashtable indvHashtable;
    Hashtable accessListTable;
    Vector accessListVector;

    eventLog.println(getLogHeading(clientID) + "inside addIndToVector");

    //for (int i = 0; i < IndArray.length; i++) {
    for (int i = IndArray.length - 1; i >= 0; i--) {
	if (v.size() >= maxClientVectorSize) {
	  v.removeElementAt(0);
	  eventLog.println(getLogHeading(clientID) + "Queue full ! First item removed. Items left : " + v.size());
	  //sb.append(getLogHeading() + "Queue full; First item removed ! Items left : " + v.size());
	}
	accessListVector = new Vector();
	accessListVector.addElement(clientID);
	accessListTable = new Hashtable();
	accessListTable.put(IndArray[i], accessListVector);
	indvHashtable = new Hashtable();
	indvHashtable.put(IndArray[i].toString(), accessListTable);
	v.addElement(indvHashtable);
	eventLog.println(getLogHeading(clientID) + "New imigrant added to end of queue. Number of items in queue is now : " + v.size());
	sb.append(getLogHeading(ServletName) + "Imigrant received has a fitness of " + IndArray[i].hits + ".\n");
	//sb.append(getLogHeading() + "New imigrant added to end of queue. Number of items in queue is now : " + v.size());
    }
  }


  void addIndToNewVector() {

    eventLog.println(getLogHeading(clientID) + "inside addIndToNewVector()");

    clientVector = new Vector();
    addIndToVector(clientVector);
    eventLog.println(getLogHeading(clientID) + "New vector created and individuals added to the vector.");
    
    popPool.put(clientID, clientVector); 
    eventLog.println(getLogHeading(clientID) + "clientID and its vector of hashtables added to popPool");

  }    


  public String getServletInfo() {
    return "PopServlet to distribute population";
  }
  
}

