package bham.cs.fsc;

import java.io.*;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.zip.*;    
import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;

//import bham.cs.fsc.gp.Individual;
//import bham.cs.fsc.gp.Program;
//import bham.cs.fsc.gp.Condition;
import bham.cs.fsc.gp.ResultsExpThread;




public class StatExpServlet extends HttpServlet  {

  public PrintStream eventLog;

  public static final String currentProblem = "SantaFe";
  public static final String ServletName = "StatServlet";
  public static final String servletLogDir = "/home/students/acs97/fsc/ExpServletLog/";

  public static final String eventLogFileName = servletLogDir + "Servlet.StatEventlog";
  public static final String solSettingsFileName = servletLogDir + "Servlet.SolSettings";
  public static final String resultsFileName = servletLogDir + "Servlet.Results";
  public static final String solClientIDsFileName = servletLogDir + "Servlet.SolClientIDs";
  public static final String statFileName = servletLogDir + "Servlet.StatReport";

  public Hashtable endOfRunTable;
  public static Hashtable settingsTable = new Hashtable();
  public static Hashtable resultsTable = new Hashtable();

  public static int[] popSz_Array = new int[4];
  public static int[] maxGen_Array = new int[4];
  public static int[] expIntv_Array = new int[4];
  public static int[] expNum_Array = new int[3]; 
  public static int[] impNum_Array = new int[3];
  public static int[] maxDepthNewIndv_Array = new int[3]; 
  public static int[] maxDepthAfterCrossover_Array = new int[3];
  public static int[] maxDepthInMutants_Array = new int[3];
  public static int[] crossOverProb_Array = new int[3]; 
  public static int[] reprodProb_Array = new int[3]; 
  public static int[] mutationProb_Array = new int[3]; 
  public static int[] genMethod_Array = new int[3]; 
  public static int[] selMethod_Array = new int[2]; 
  public static int[] elitism_Array = new int[2]; 
  public static int[] tournamentSz_Array = new int[4]; 
  /*
  public static int nrOfSolFound;
  public static int nrOfNoSolFound;
  public static int nrOfRunCompleted;
  public static int nrOfRunNotCompleted;
  */
  public static Integer nrOfSolFoundObj;
  public static Integer nrOfNoSolFoundObj;
  public static Integer nrOfRunCompletedObj;
  public static Integer nrOfRunNotCompletedObj;

  public static int[] endGenOfCompletedRun = new int[4];
  public static int[] endGenOfUncompletedRun = new int[4];
  public static int[] completeRunFoodEaten = new int[4];
  public static int[] uncompletedRunFoodEaten = new int[4];
  public static int[] genOfSolFound = new int[4];


  public String clientID;
  public boolean solFound;
  //StringBuffer sb;
  public HttpServletRequest req;
  public static StringBuffer solClientIDsb;
  public Thread pThread;

  String fileDateTime;


  public void init(ServletConfig c) throws ServletException {
    
    super.init(c);

    //Opening event log file
    fileDateTime = DateFormat.getDateInstance(DateFormat.SHORT, Locale.CHINA).format(new Date()) + "_" + 
      DateFormat.getTimeInstance(DateFormat.SHORT, Locale.UK).format(new Date()) ;  

    
    try {
      eventLog = new PrintStream(new FileOutputStream(eventLogFileName + "_" + fileDateTime));
    } 
    catch (IOException e) {
      eventLog.println(getLogHeading(ServletName) + "IOException at init() : " + e);
    }
    
    //Opening solution settings file
    //FileInputStream sfis;
    //GZIPInputStream sgzis;
    //DataInputStream sin;
    ObjectInputStream objIn;
    
    if (new File(solSettingsFileName).exists()) {
      try {
	/*
	sfis = new FileInputStream(solSettingsFileName); //Read from file
	sgzis = new GZIPInputStream(sfis); //Uncompress
	sin = new ObjectInputStream(sgzis); //Read objects
	*/
	
	objIn = new ObjectInputStream(new GZIPInputStream(new FileInputStream(solSettingsFileName)));
      
	eventLog.println(getLogHeading(ServletName) + "SolSettins ObjectInputStream successfully created.");
     
	try {
	  settingsTable = (Hashtable)objIn.readObject();
	  eventLog.println(getLogHeading(ServletName) + "SolSettings object read successfully.");
	}
	catch (ClassNotFoundException e) {}
      
	popSz_Array = (int[])settingsTable.get("Pop_Size_Array");
	maxGen_Array = (int[])settingsTable.get("Max_Gen_Array");
	expIntv_Array = (int[])settingsTable.get("Export_Intv_Array");
	expNum_Array = (int[])settingsTable.get("Export_Num_Array");
	impNum_Array = (int[])settingsTable.get("Import_Num_Array");
	maxDepthNewIndv_Array = (int[])settingsTable.get("Max_Depth_For_New_Indv_Array");
	maxDepthAfterCrossover_Array = (int[])settingsTable.get("Max_Depth_After_Crossover_Array");
	maxDepthInMutants_Array = (int[])settingsTable.get("Max_Depth_For_Mutants_Array");
	crossOverProb_Array = (int[])settingsTable.get("Crossover_Prob_Array");
	reprodProb_Array = (int[])settingsTable.get("Reproduction_Prob_Array");
	mutationProb_Array = (int[])settingsTable.get("Mutation_Prob_Array");
	genMethod_Array = (int[])settingsTable.get("Method_Of_Gen_Array");
	selMethod_Array = (int[])settingsTable.get("Method_Of_Sel_Array");
	elitism_Array = (int[])settingsTable.get("Elitism_Array");
	tournamentSz_Array = (int[])settingsTable.get("Tournament__Size_Array");

	//count = sin.readInt();
        //sin.close();	
   	
      }
      catch (IOException e) {eventLog.println(getLogHeading(ServletName) + "IOException when opening input stream for Solution Settings file : " + e); }
     
    }
    else {
      eventLog.println(getLogHeading(ServletName) + "Solution Settings file does not exist. Oject input stream not created for the file.");

      //settingsTable = new Hashtable();

      initSettingsArray(popSz_Array, 4);
      initSettingsArray(maxGen_Array, 4);
      initSettingsArray(expIntv_Array, 4);
      initSettingsArray(expNum_Array, 3);
      initSettingsArray(impNum_Array, 3);
      initSettingsArray(maxDepthNewIndv_Array, 3);
      initSettingsArray(maxDepthAfterCrossover_Array, 3);
      initSettingsArray(maxDepthInMutants_Array, 3);
      initSettingsArray(crossOverProb_Array, 3);
      initSettingsArray(reprodProb_Array, 3);
      initSettingsArray(mutationProb_Array, 3);
      initSettingsArray(genMethod_Array, 3);
      initSettingsArray(selMethod_Array, 2);
      initSettingsArray(elitism_Array, 2);
      initSettingsArray(tournamentSz_Array, 4);

      eventLog.println(getLogHeading(ServletName) + "Settings array initialised.");

    }
    
    
    //Opening results file
    /*
    FileInputStream rfis;
    GZIPInputStream rgzis;
    DataInputStream rin;
    */

    if (new File(resultsFileName).exists()) {
      try {
	/*
	rfis = new FileInputStream(resultsFileName); //Read from file
	rgzis = new GZIPInputStream(rfis); //Uncompress
	rin = new DataInputStream(rgzis); //Read objects
	*/

	objIn = new ObjectInputStream(new GZIPInputStream(new FileInputStream(resultsFileName)));	  
	eventLog.println(getLogHeading(ServletName) + "Results file input stream opened");

	try {
	  resultsTable = (Hashtable)objIn.readObject();
	  eventLog.println(getLogHeading(ServletName) + "results object read successfully.");
	}
	catch (ClassNotFoundException e) {}
	/*
	nrOfSolFound = ((Integer)resultsTable.get("NrOfSolFound")).intValue();
	nrOfNoSolFound = ((Integer)resultsTable.get("NrOfNoSolFound")).intValue();
	nrOfRunCompleted = ((Integer)resultsTable.get("NrOfRunCompleted")).intValue();
	nrOfRunNotCompleted = ((Integer)resultsTable.get("NrOfRunNotCompleted")).intValue();
	*/
	nrOfSolFoundObj = (Integer)resultsTable.get("NrOfSolFound");
	nrOfNoSolFoundObj = (Integer)resultsTable.get("NrOfNoSolFound");
	nrOfRunCompletedObj = (Integer)resultsTable.get("NrOfRunCompleted");
	nrOfRunNotCompletedObj = (Integer)resultsTable.get("NrOfRunNotCompleted");

        endGenOfCompletedRun = (int[])resultsTable.get("EndGenOfCompleteRun");
	endGenOfUncompletedRun = (int[])resultsTable.get("EndGenOfUncompletedRun");
	completeRunFoodEaten = (int[])resultsTable.get("CompleteRunFoodEaten");
	uncompletedRunFoodEaten = (int[])resultsTable.get("UncompletedRunFoodEaten");
	genOfSolFound = (int[])resultsTable.get("GenOfSolFound");

	/*
	  nrOfSolFound = rin.readInt();
	  nrOfNoSolFound = rin.readInt();
	  nrOfRunCompleted = rin.readInt();
	  nrOfRunNotCompleted = rin.readInt();	  
	  rin.close();	
	*/
	
	eventLog.println(getLogHeading(ServletName) + "results read from file successfully.");
      }
	
      catch (IOException e) {eventLog.println(getLogHeading(ServletName) + "IOException when opening input stream for Results file : " + e); }
	
    }
    else {
      eventLog.println(getLogHeading(ServletName) + "Results file does not exist. Data input stream not created for the file.");
      /*
      nrOfSolFound = 0;
      nrOfNoSolFound = 0;
      nrOfRunCompleted = 0;
      nrOfRunNotCompleted = 0;
      */
      nrOfSolFoundObj = new Integer(0);
      nrOfNoSolFoundObj = new Integer(0);
      nrOfRunCompletedObj = new Integer(0);
      nrOfRunNotCompletedObj = new Integer(0);      

      initSettingsArray(endGenOfCompletedRun, 4);
      initSettingsArray(endGenOfUncompletedRun, 4);
      initSettingsArray(completeRunFoodEaten, 4);
      initSettingsArray(uncompletedRunFoodEaten, 4);
      initSettingsArray(genOfSolFound, 4);

      eventLog.println(getLogHeading(ServletName) + "Results variables initialised.");
    }       


    //start thread to print the statistics report.
    //eventLog.println(getLogHeading(ServletName) + "Starting thread to print statistics report at start of servlet.");
    //pThread = new ReportThread(this); 
    //pThread.start();
    //eventLog.println(getLogHeading(ServletName) + "Thread to print statistics report started.");

    //Reading of solution client id file
      BufferedReader d = null;
      String line = "";
      solClientIDsb = new StringBuffer();
      boolean fileFound = true;
	
      try {
	d = new BufferedReader(new FileReader(solClientIDsFileName));
	eventLog.println(getLogHeading(ServletName) + "Reading contents from solution clientID file");
      } 
      catch(FileNotFoundException e) {
	  //file should have been created when client requests for seed. If client failed to receive seed, it will use the default seed 12345 and will run standalone without exchange of individuals.
	eventLog.println(getLogHeading(ServletName) + "solution clientID file not found !!!");
	fileFound = false;
      }
	
      if (fileFound) {
	boolean cont = true ;
	while (cont == true) {
	  try {
	    line = (d.readLine()) ;
	  } catch(IOException e) {
	    eventLog.println(getLogHeading(ServletName) + "readLine for Client file error: " + e);
	    cont = false ;
	  }
	  if (line != null) {
	    //eventLog.println(getLogHeading(clientID) + line);
	    solClientIDsb.append(line + "\n");	    
	  } 
	  else {
	    //eventLog.println(getLogHeading(clientID) + "line is null");
	    cont = false;
	  }
	}
      }

    eventLog.println(getLogHeading(ServletName) + "StatServlet initialised.");
    

    fileDateTime = DateFormat.getDateInstance(DateFormat.SHORT, Locale.CHINA).format(new Date()) + "_" + 
      DateFormat.getTimeInstance(DateFormat.SHORT, Locale.UK).format(new Date()) ;  
    
    
    PrintStream statFileStream = null;
    try {
      statFileStream = new PrintStream(new FileOutputStream(statFileName + "_" + fileDateTime));
      eventLog.println(getLogHeading(ServletName) + "statFile opened");
    } 
    catch (IOException e) {
      eventLog.println(getLogHeading(ServletName) + "IOException at init() : " + e);
    }
    if (statFileStream != null) {
      printStatReport(statFileStream);

      statFileStream.flush();
      statFileStream.close();
    }

  }



  public String getLogHeading(String id) {
    return DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT, Locale.UK).format(new Date()) + " : " + id + " : ";
  }


  void initSettingsArray(int[] a, int l) {    
    for (int i = 0; i< l; i++) {
      a[i] = 0;
    }
  }


  /*    
  void classifyAndCount(int[] iArray, int item, int r1, int r2, int r3) {
    boolean notDone = true;
    int i = 0;
    int[] rArray = {r1, r2, r3};
  
    if (iArray.length == (rArray.length + 1)) {
      eventLog.println(getLogHeading(clientID) + "Matched number of array elements and range intervals.");
      while ((notDone) && (i < iArray.length -1) && (i < rArray.length)) {
	if (item <= rArray[i]) {
	  iArray[i] ++;
	  notDone = false;
	}
	i++;
      }

      if (notDone) {
	if (item > rArray[i-1]) {
	  iArray[iArray.length -1] ++;
	  notDone = false;
	}
      }
    }
    else {
      eventLog.println(getLogHeading(clientID) + "Unmatched number of array elements and range intervals.");
    }
  }
  */
  
  public void doPost(HttpServletRequest req,
		    HttpServletResponse res)
    throws IOException, OptionalDataException {

      this.req = req;

      /*
      boolean solFound;
      int endGen;
      int maxGen;
      int nrOfFoodEaten;

      Individual solutionIndv;

      int solPopSz; 
      int solMaxGen; 
      int solExpIntv; 
      int solExpNum;
      int solImpNum;
      int solMaxDepthNewIndv;
      int solMaxDepthAfterCrossover; 
      int solMaxDepthInMutants; 
      double solCrossOverProb; 
      double solReprodProb;
      double solMutationProb;
      String solGenMethod;
      String solSelMethod;
      int solTournamentSz;
      */
 
      eventLog.println("*************************************");

      ObjectInputStream objIn = new ObjectInputStream(new GZIPInputStream(req.getInputStream()));
      
      eventLog.println(getLogHeading(ServletName) + "ObjectInputStream successfully created.");
     
      try {
	endOfRunTable = (Hashtable)objIn.readObject();
	eventLog.println(getLogHeading(ServletName) + "object read successfully.");
      }
      catch (ClassNotFoundException e) {}


      String sentOKMsg;

      if ((endOfRunTable != null) && (! endOfRunTable.isEmpty())) {
	clientID = (String)endOfRunTable.get("ClientID");
        solFound = ((Boolean)endOfRunTable.get("SolFound")).booleanValue();


	//eventLog.println(getLogHeading(clientID) + "number of noSolFound (b4) : " + nrOfNoSolFoundObj.intValue());
	//eventLog.println(getLogHeading(clientID) + "number of run not completed (b4) : " + nrOfRunNotCompletedObj.intValue());


	Thread rThread = new ResultsExpThread(this); 
	rThread.start();
	
	//eventLog.println(getLogHeading(clientID) + "number of noSolFound (AF) : " + nrOfNoSolFoundObj.intValue());
	//eventLog.println(getLogHeading(clientID) + "number of run not completed (AF) : " + nrOfRunNotCompletedObj.intValue());

	sentOKMsg = "End_Results_Sent_Successful";
      }
      else {
	sentOKMsg = "";
      }
	
      res.setContentType("application/octet-stream");
      
      ObjectOutputStream objOut = new ObjectOutputStream(new GZIPOutputStream(res.getOutputStream()));
      eventLog.println(getLogHeading(clientID) + "ObjectOutputStream created.");
      
      objOut.writeObject(sentOKMsg);
      //*objOut.writeObject(sendObj);
      eventLog.println(getLogHeading(clientID) + "sendOKMsg written to the servlet response output stream.");
      //sb.append(getLogHeading() + "sendIndArray written to output stream.");

      objOut.flush();
      objOut.close();  
      eventLog.println(getLogHeading(clientID) + "object output stream flushed and closed.");      
  }
   
  /* following can be done in a thread.      
      // read in the servlet's parameters 
      String clientQueryString = req.getQueryString();
      String clientProbName = clientQueryString.substring(clientQueryString.indexOf("=") + 1);
      String clientIPAddr = req.getRemoteAddr();
      String clientHostName = req.getRemoteHost();
      String clientProtocol = req.getProtocol();

      if ((clientProbName != null) && (clientProbName.trim()).equals(currentProblem.trim())) {

	eventLog.println(getLogHeading(ServletName) + "clientProbName not null and equals to " + currentProblem);

	clientID = (String)endOfRunTable.get("ClientID");
	solFound = ((Boolean)endOfRunTable.get("SolFound")).booleanValue();
	endGen = ((Integer)endOfRunTable.get("EndGen")).intValue();
	maxGen = ((Integer)endOfRunTable.get("MaxGen")).intValue();
	nrOfFoodEaten = ((Integer)endOfRunTable.get("FoodEaten")).intValue();
	solutionIndv = (Individual) endOfRunTable.get("Solution");
	solPopSz = ((Integer)endOfRunTable.get("Pop_Size")).intValue();
	solMaxGen = ((Integer)endOfRunTable.get("Max_Gen")).intValue();
	solExpIntv = ((Integer)endOfRunTable.get("Export_Interval")).intValue();
	solExpNum = ((Integer)endOfRunTable.get("Export_Num")).intValue();
	solImpNum = ((Integer)endOfRunTable.get("Import_Num")).intValue();
	solMaxDepthNewIndv = ((Integer)endOfRunTable.get("Max_Depth_For_New_Indv")).intValue();
	solMaxDepthAfterCrossover = ((Integer)endOfRunTable.get("Max_Depth_For_Indv_After_Crossover")).intValue();
	solMaxDepthInMutants = ((Integer)endOfRunTable.get("Max_Depth_For_New_Subtrees_In_Mutants")).intValue();
	solCrossOverProb = ((Double)endOfRunTable.get("Crossover_Prob")).doubleValue();
	solReprodProb = ((Double)endOfRunTable.get("Reproduction_Prob")).doubleValue();
	solMutationProb = ((Double)endOfRunTable.get("Mutation_Prob")).doubleValue();
	solGenMethod = (String)endOfRunTable.get("Method_Of_Generation");
	solSelMethod = (String)endOfRunTable.get("Method_Of_Selection");
	solTournamentSz = ((Integer)endOfRunTable.get("Tournament_selection_group_size")).intValue();
	



	String fileName = servletLogDir + currentProblem + "." +  clientID + ".params";
	eventLog.println(getLogHeading(clientID) + "Client's file name : " + fileName);
	
	BufferedReader d = null;
	String line = "";
	sb = new StringBuffer();
	boolean fileFound = true;
	
	try {
	  d = new BufferedReader(new FileReader(fileName));
	  eventLog.println(getLogHeading(clientID) + "Reading contents from client file");
	  } 
	catch(FileNotFoundException e) {
	  //file should have been created when client requests for seed. If client failed to receive seed, it will use the default seed 12345 and will run standalone without exchange of individuals.
	  eventLog.println(getLogHeading(clientID) + "file not found !!!");
	  fileFound = false;
	}
	
	if (fileFound) {
	  boolean cont = true ;
	  while (cont == true) {
	    try {
	      line = (d.readLine()) ;
	    } catch(IOException e) {
	      eventLog.println(getLogHeading(clientID) + "readLine for Client file error: " + e);
	      cont = false ;
	    }
	    if (line != null) {
	      //eventLog.println(getLogHeading(clientID) + line);
	      sb.append(line + "\n");	    
	    } 
	    else {
	      //eventLog.println(getLogHeading(clientID) + "line is null");
	      cont = false;
	    }
	  }
	}


	if (! solFound) {
	  nrOfNoSolFound ++;
	  sb.append("*** Solution NOT found in this run ! ***\n");

	  if (endGen == maxGen) {
	    sb.append("Run completed (endGen = maxGen)\n");
	    nrOfRunCompleted ++;
	    classifyAndCount(endGenOfCompletedRun, endGen, 10, 30, 50);
	    classifyAndCount(completeRunFoodEaten, nrOfFoodEaten, 20, 60, 89); 
	  }
	  else {
	    sb.append("!! Run was terminated prematurely !!\n");
	    nrOfRunNotCompleted ++;
	    classifyAndCount(endGenOfUncompletedRun, endGen, 10, 30, 50);
	    classifyAndCount(UncompletedRunFoodEaten, nrOfFoodEaten, 20, 60, 89);
	  }

	  sb.append("Run ends at generation " + endGen + "\n");
	  sb.append("Number of food pellets eaten : " + nrOfFoodEaten + "\n");

	}
	else {
	  nrOfSolFound ++;
	  nrOfRunCompleted ++;
	  classifyAndCount(genOfSolFound, endGen, 10, 30, 50);
	 
	  //classifyAndCount settings for the run where a solution is found.
	  classifyAndCount(popSz_Array, solPopSz, 100, 300, 500);
	  classifyAndCount(maxGen_Array, solMaxGen, 10, 30, 50);
	  classifyAndCount(expIntv_Array, solExpIntv, 10, 20, 30);
	  classifyAndCount(expNum_Array, solExpNum, 1, 5);
	  classifyAndCount(impNum_Array, solImpNum, 1, 5);
	  classifyAndCount(maxDepthNewIndv_Array, solMaxDepthNewIndv, 1, 5);
	  classifyAndCount(maxDepthAfterCrossover_Array, solMaxDepthAfterCrossover, 5, 10);
	  classifyAndCount(maxDepthInMutants_Array, solMaxDepthInMutants, 1, 5);
	  classifyAndCount(crossOverProb_Array, solCrossOverProb, 10, 50);
	  classifyAndCount(reprodProb_Array, solReprodProb, 10, 50);
	  classifyAndCount(mutationProb_Array, solMutationProb, 10, 50);
	  classifyAndCount(genMethod_Array,  solGenMethod, 0, 0);
	  classifyAndCount(selMethod_Array, solSelMethod, 0, 0);
	  classifyAndCount(tournamentSz_Array, solTournamentSz, 5, 10, 15);
	  
	  //convert individual into a string and write it with other results to the client file.
	  sb.append("*** Solution found in this run ! ***\n");
	  sb.append("Solution is found in generation " + endGen + "\n");
	  sb.append("Solution is :\n");
	  sb.append(solutionIndv.toString() + "\n");	    
	} //else (solFound)	
      }
      else {
	eventLog.println(getLogHeading(clientID) + "Problem name does not match.");
      }


      //write client log into file and close the stream.
      //if (fileFound) {
	String clientLogString = sb.toString();
	eventLog.println(getLogHeading(clientID) + "string buffer for client converted to string");
	PrintStream clientLog = new PrintStream(new FileOutputStream(fileName));
	eventLog.println(getLogHeading(clientID) + "client file " + fileName + " found and opened.");
	clientLog.println(clientLogString);
	eventLog.println(getLogHeading(clientID) + "buffer string written to client file");
	clientLog.flush();
	clientLog.close();
	eventLog.println(getLogHeading(clientID) + "client file flushed and closed");
	//}

      updateSolSettingsFile();
      updateResultsFile();
      updateLogFile();
      
      //*Nothing needs to be sent back to the client and so no object output stream or res.getOutputStream needs to be created. 	
  
  }  
  */
  
  public void updateSolClientIDFile() {

    String clientLogString = solClientIDsb.toString();
    eventLog.println(getLogHeading(clientID) + "string buffer for sol clientID converted to string");
    try {
      PrintStream clientLog = new PrintStream(new FileOutputStream(solClientIDsFileName));
      eventLog.println(getLogHeading(clientID) + "sol clientID file " + solClientIDsFileName + " found and opened.");
      clientLog.println(clientLogString);
      eventLog.println(getLogHeading(clientID) + "buffer string written to sol clientID file");
      clientLog.flush();
      clientLog.close();
      eventLog.println(getLogHeading(clientID) + "sol clientID file flushed and closed");	
    }
    catch (IOException e) {
      eventLog.println(getLogHeading(clientID) + "IOException when writing to output stream for solution clientID file : " + e);
    }
  }


  public void updateSolSettingsFile() {
    
    synchronized (settingsTable) {
    settingsTable = new Hashtable();
    /*
    settingsTable.put("Pop_Size_Array", popSz_Array);    
    settingsTable.put("Max_Gen_Array", maxGen_Array);
    settingsTable.put("Export_Intv_Array", expIntv_Array);
    settingsTable.put("Export_Num_Array", expNum_Array);
    settingsTable.put("Import_Num_Array", impNum_Array);
    settingsTable.put("Max_Depth_For_New_Indv_Array", maxDepthNewIndv_Array);
    settingsTable.put("Max_Depth_After_Crossover_Array", maxDepthAfterCrossover_Array);
    settingsTable.put("Max_Depth_For_Mutants_Array", maxDepthInMutants_Array);
    settingsTable.put("Crossover_Prob_Array", crossOverProb_Array);
    settingsTable.put("Reproduction_Prob_Array", reprodProb_Array);
    settingsTable.put("Mutation_Prob_Array", mutationProb_Array);
    settingsTable.put("Method_Of_Gen_Array", genMethod_Array);
    settingsTable.put("Method_Of_Sel_Array", selMethod_Array);
    settingsTable.put("Tournament__Size_Array", tournamentSz_Array);
    */
    
    synUpdateSettings("Pop_Size_Array", popSz_Array);    
    synUpdateSettings("Max_Gen_Array", maxGen_Array);
    synUpdateSettings("Export_Intv_Array", expIntv_Array);
    synUpdateSettings("Export_Num_Array", expNum_Array);
    synUpdateSettings("Import_Num_Array", impNum_Array);
    synUpdateSettings("Max_Depth_For_New_Indv_Array", maxDepthNewIndv_Array);
    synUpdateSettings("Max_Depth_After_Crossover_Array", maxDepthAfterCrossover_Array);
    synUpdateSettings("Max_Depth_For_Mutants_Array", maxDepthInMutants_Array);
    synUpdateSettings("Crossover_Prob_Array", crossOverProb_Array);
    synUpdateSettings("Reproduction_Prob_Array", reprodProb_Array);
    synUpdateSettings("Mutation_Prob_Array", mutationProb_Array);
    synUpdateSettings("Method_Of_Gen_Array", genMethod_Array);
    synUpdateSettings("Method_Of_Sel_Array", selMethod_Array);
    synUpdateSettings("Elitism_Array", elitism_Array);
    synUpdateSettings("Tournament__Size_Array", tournamentSz_Array);


    try {
      ObjectOutputStream objOut= new ObjectOutputStream(new GZIPOutputStream(new FileOutputStream(solSettingsFileName)));
      eventLog.println(getLogHeading(ServletName) + "SolSettings ObjectOutputStream successfully created.");

      objOut.writeObject(settingsTable);
      eventLog.println(getLogHeading(ServletName) + "solSettings Hashtable object written to the output stream for solSettings file ");

      objOut.flush();
      objOut.close();
      eventLog.println(getLogHeading(ServletName) + "output stream for solSettings file flushed and closed");
    }
    catch (IOException e) {
      eventLog.println(getLogHeading(ServletName) + "IOException when writing to output stream for solSettings file : " + e);
    }
    }
  }


  public void updateResultsFile() {

    synchronized (resultsTable) {
    resultsTable = new Hashtable(); 

    /*
    resultsTable.put("NrOfSolFound", nrOfSolFoundObj);
    resultsTable.put("NrOfNoSolFound", nrOfNoSolFoundObj);
    resultsTable.put("NrOfRunCompleted", nrOfRunCompletedObj);
    resultsTable.put("NrOfRunNotCompleted", nrOfRunNotCompletedObj);
    
    resultsTable.put("EndGenOfCompleteRun", endGenOfCompletedRun);
    resultsTable.put("EndGenOfUncompletedRun", endGenOfUncompletedRun);
    resultsTable.put("CompleteRunFoodEaten", completeRunFoodEaten);
    resultsTable.put("UncompletedRunFoodEaten", uncompletedRunFoodEaten);
    resultsTable.put("GenOfSolFound", genOfSolFound);
    */

    synUpdateResultsInt("NrOfSolFound", nrOfSolFoundObj);
    synUpdateResultsInt("NrOfNoSolFound", nrOfNoSolFoundObj);
    synUpdateResultsInt("NrOfRunCompleted", nrOfRunCompletedObj);
    synUpdateResultsInt("NrOfRunNotCompleted", nrOfRunNotCompletedObj);
    
    synUpdateResults("EndGenOfCompleteRun", endGenOfCompletedRun);
    synUpdateResults("EndGenOfUncompletedRun", endGenOfUncompletedRun);
    synUpdateResults("CompleteRunFoodEaten", completeRunFoodEaten);
    synUpdateResults("UncompletedRunFoodEaten", uncompletedRunFoodEaten);
    synUpdateResults("GenOfSolFound", genOfSolFound);



    try {
      ObjectOutputStream objOut= new ObjectOutputStream(new GZIPOutputStream(new FileOutputStream(resultsFileName)));
      eventLog.println(getLogHeading(ServletName) + "Results ObjectOutputStream successfully created.");

      objOut.writeObject(resultsTable);
      eventLog.println(getLogHeading(ServletName) + "results Hashtable object written to the output stream for results file ");

      objOut.flush();
      objOut.close();
      eventLog.println(getLogHeading(ServletName) + "output stream for results file flushed and closed");
    }
    catch (IOException e) {
      eventLog.println(getLogHeading(ServletName) + "IOException when writing to output stream for results file : " + e);
    }
    }
  }

  
  public void synUpdateSettings(String title, int[] iArray) {
    synchronized (iArray) {
      settingsTable.put(title, iArray);
    }
  }
  
  public void synUpdateResults(String title, int[] rArray) {
    synchronized (rArray) {
      resultsTable.put(title, rArray);
    }
  }

  public void synUpdateResultsInt(String title, Integer IntObj) {
    synchronized (IntObj) {
      resultsTable.put(title, IntObj);
    }
  }


  public void printStatReport(PrintStream ps) {
    
    ps.println("\n");
    printIntArray(ps, popSz_Array, "Population Sizes");
    printIntArray(ps, maxGen_Array, "Max Gens");
    printIntArray(ps, expIntv_Array, "Export Intervals");
    printIntArray(ps, expNum_Array, "Num to export");
    printIntArray(ps, impNum_Array, "Num to import");
    printIntArray(ps, maxDepthNewIndv_Array, "Max depth for new individual");
    printIntArray(ps, maxDepthAfterCrossover_Array, "Max depth for individuals after crossover");
    printIntArray(ps, maxDepthInMutants_Array, "Max depth for individuals in mutants");
    printIntArray(ps, crossOverProb_Array, "Cross over probabilities");
    printIntArray(ps, reprodProb_Array, "Reproduction probabilities");
    printIntArray(ps, mutationProb_Array, "Mutation probabilities");
    printIntArray(ps, genMethod_Array, "Generation Methods");
    printIntArray(ps, selMethod_Array, "Selection Methods");
    printIntArray(ps, elitism_Array, "Elitism");
    printIntArray(ps, tournamentSz_Array, "Tournament Selection group sizes");
    
    printIntObj(ps, nrOfSolFoundObj, "Num of runs with solution found");
    printIntObj(ps, nrOfNoSolFoundObj, "Num of runs with no solution found");
    printIntObj(ps, nrOfRunCompletedObj, "Num of runs which are completed");
    printIntObj(ps, nrOfRunNotCompletedObj, "Num of runs terminated prematurely");

    printIntArray(ps, endGenOfCompletedRun, "Gen Num where run completes");
    printIntArray(ps, endGenOfUncompletedRun, "Gen Num where run was prematurely terminated");
    printIntArray(ps, completeRunFoodEaten, "Num of food pellets eaten in a completed run");
    printIntArray(ps, uncompletedRunFoodEaten, "Num of food pellets eaten in a run which was terminated prematurely");
    printIntArray(ps, genOfSolFound, "Gen Num of run in which a solution was found");

  }


  void printIntArray(PrintStream printstream, int[] iArray, String heading) {
    if ((iArray != null) && (iArray.length != 0)) {
      printstream.print(getLogHeading(clientID) + heading + " : ");
      for (int i = 0; i < iArray.length; i++) {	
	printstream.print(iArray[i] + "    ");
      }
      printstream.println("");
    }
    else {
      printstream.println(getLogHeading(clientID) + heading + " is null or empty.");
    }    
  }
  
  
  void printIntObj(PrintStream printstream, Integer intObj, String heading) {
    if (intObj != null) {
      printstream.print(getLogHeading(clientID) + heading + " : ");
      printstream.println(intObj.intValue());
    }
    else {
      printstream.println(getLogHeading(clientID) + heading + " is null.");
    }
  }  
  

  public void destroy() {

    updateSolSettingsFile();
    eventLog.println(getLogHeading(ServletName) + "solSettingsFile updated before servlet is destroyed.");
    updateResultsFile();
    eventLog.println(getLogHeading(ServletName) + "resultsFile updated before servlet is destroyed.");

    if ((solClientIDsb != null) && (solClientIDsb.length() != 0)) {
      eventLog.println(getLogHeading(ServletName) + "solClientIDsb not null and is not empty. Updating file before servlet is destroyed.");
      updateSolClientIDFile();
    }
    else {
      eventLog.println(getLogHeading(ServletName) + "solClientIDsb is either null or empty. File not updated/created before servlet is destroyed.");
    }

    //start thread to print the statistics report.
    //*eventLog.println(getLogHeading(ServletName) + "Starting thread to print statistics report before servlet is destroyed.");
    //*pThread = new ReportThread(this); 
    //*pThread.start();
    //*eventLog.println(getLogHeading(ServletName) + "Thread to print statistics report started.");

    fileDateTime = DateFormat.getDateInstance(DateFormat.SHORT, Locale.CHINA).format(new Date()) + "_" + 
      DateFormat.getTimeInstance(DateFormat.SHORT, Locale.UK).format(new Date()) ;  

    
    PrintStream statFileStream = null;
    try {
      statFileStream = new PrintStream(new FileOutputStream(statFileName + "_" + fileDateTime));
      eventLog.println(getLogHeading(ServletName) + "statFile opened");
    } 
    catch (IOException e) {
      eventLog.println(getLogHeading(ServletName) + "IOException at init() : " + e);
    }
    if (statFileStream != null) {
      printStatReport(statFileStream);

      statFileStream.flush();
      statFileStream.close();
    }

    //close eventLog stream
    eventLog.println(getLogHeading(ServletName) + "Flushing and closing eventLog stream");
    eventLog.flush();
    eventLog.close();

  }


  public String getServletInfo() {
    return "StatServlet : gather and compile statistics for usage and results generated by the DGP system.\nAuthor : Phyllis Chong";
  }
  
  }

