//package exp;
package bham.cs.fsc.exp;
import bham.cs.fsc.ui.*;
import bham.cs.fsc.gp.*;
import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Button;
import java.awt.Event;
import java.awt.Label;
import java.awt.Component;
import java.awt.Color;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.FileDialog;
import java.awt.Font;
import java.io.File;

/**
* 
* This is the modal dialog to be displayed when a user specified file is not found.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class FileIODialog extends Dialog {
     
	private Button okButton;
        private TextArea dialogText;

  public FileIODialog(Frame parent, String dialogMsg, String title) {
	        super(parent, new Rectangle(8, 8, 210, 75), title);
		//	Weird: The AWT is supposed to make the dialog window a child
		//	of the main frame. But it takes the desktop top left corner 
		//	as coordinate	origin instead of the frame's.
		//	On some systems, modal dialogs are fixed on the screen, therefore,
		//	I have to put my dialog near the top left corner, so that it is fully
		//	visible.
		//setResizable(false);
		setResizable(true);
		
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		buttonPanel.setFont(new Font("Courier",Font.BOLD,11));
	        okButton = new Button("OK");
		buttonPanel.add("Center",okButton);

		Panel textPanel = new Panel();
		textPanel.setLayout(new FlowLayout()); //default layout for panels
		textPanel.setFont(new Font("Courier",Font.PLAIN,11));
		//fileNotFoundText = new TextArea(fileName + " is NOT found. Please check if it is in another directory or provide another file name. ",4,45,TextArea.SCROLLBARS_NONE);
		//*dialogText = new TextArea(dialogMsg,5,50,TextArea.SCROLLBARS_NONE);
		dialogText = new TextArea(5, 50);
		dialogText.setText(dialogMsg);
		
		dialogText.setEditable(false);
		textPanel.add(dialogText);

		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", textPanel);
		add("Bottom Wide", buttonPanel);	
	}

	/**
	* Is called whenever the user clicks a command button.
	*/
	public boolean action(Event evt, Object what) {
		if (evt.target == okButton) {

		  dispose();
	          return true;
		}
		
		return false;
	}


}








