package bham.cs.fsc.exp;
import bham.cs.fsc.ui.StackLayout;
import bham.cs.fsc.gp.*;
import java.awt.Frame;
//import java.awt.Rectangle;
import java.awt.Button;
import java.awt.Event;
import java.awt.Label;
import java.awt.Component;
//import java.awt.Color;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Panel;
//import java.awt.BorderLayout;
import java.awt.FlowLayout;
//import java.awt.FileDialog;
import java.awt.Font;
import java.awt.Dialog;
import java.awt.TextField;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
//import java.io.File;

/**
* 
* This is the modal dialog for requesting the user to enter his/her name when they found a solution to a problem.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class NameDialog extends Dialog {
     
  private Button setButton;
  private Button cancelButton;
  
  private TextArea msgText;
  private TextField nameField;
  private TextField orgField;
  private TextField designationField;
  
  public String name = "";
  public String org ="";
  public String designation = "";

  Frame parent;
 

  public NameDialog(Frame parent, String msg, String field1, String field2, String field3, String title) {
    //super(parent, new Rectangle(8, 8, 265, 160),
    //super(parent, new Rectangle(8, 8, 375, 155),
    //title);
    //	Weird: The AWT is supposed to make the dialog window a child
    //	of the main frame. But it takes the desktop top left corner 
    //	as coordinate	origin instead of the frame's.
    //	On some systems, modal dialogs are fixed on the screen, therefore,
    //	I have to put my dialog near the top left corner, so that it is fully
    //	visible.
    //setResizable(false);

    super(parent, title, true);
    this.parent = parent;

    setResizable(true);
		
    Panel p1 = new Panel();
    p1.setFont(new Font("Courier", Font.BOLD, 12));
    msgText =  new TextArea(12, 70);
    msgText.setText(msg);
    msgText.setEditable(false);
    p1.add(msgText);
    
    GridBagLayout gridbag;
    GridBagConstraints c;


    Panel p2 = new Panel();

    gridbag = new GridBagLayout();
    c = new GridBagConstraints();

    p2.setFont(new Font("Courier", Font.BOLD, 13));
    Label l1 = new Label(field1.trim() + " : ", Label.LEFT);
    nameField = new TextField(22);

    p2.setLayout(gridbag);
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    //p2.setLayout(new GridLayout(1,5));
    gridbag.setConstraints(l1,c);
    p2.add(l1);
    c.gridwidth = GridBagConstraints.REMAINDER; //end row
    gridbag.setConstraints(nameField,c);
    p2.add(nameField);


    Panel p3 = new Panel();
    gridbag = new GridBagLayout();
    c = new GridBagConstraints();

    p3.setFont(new Font("Courier", Font.BOLD, 13));
    Label l2 = new Label(field2.trim() + " : ", Label.LEFT);
    orgField = new TextField(30);

    p3.setLayout(gridbag);
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    //p3.setLayout(new GridLayout(1,5));
    gridbag.setConstraints(l2,c);
    p3.add(l2);
    c.gridwidth = GridBagConstraints.REMAINDER; //end row
    gridbag.setConstraints(orgField,c);
    p3.add(orgField);


    Panel p4 = new Panel();
    gridbag = new GridBagLayout();
    c = new GridBagConstraints();

    p4.setFont(new Font("Courier", Font.BOLD, 13));
    Label l3 = new Label(field3.trim() + " : ", Label.LEFT);
    designationField = new TextField(29);

    p4.setLayout(gridbag);
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    //p4.setLayout(new GridLayout(1,5));
    gridbag.setConstraints(l3,c);
    p4.add(l3);
    c.gridwidth = GridBagConstraints.REMAINDER; //end row
    gridbag.setConstraints(designationField,c);
    //designationField = new TextField(20);
    p4.add(designationField);

    Panel p5 = new Panel();
    p5.setFont(new Font("Courier", Font.BOLD, 13));
    p5.setLayout(new GridLayout(1,5));
    //p5.setLayout(new FlowLayout(FlowLayout.CENTER));
    setButton = new Button("Set");
    cancelButton = new Button("Cancel");
    p5.add(new Label(""));
    p5.add(setButton);
    p5.add(new Label(""));
    p5.add(cancelButton);
    p5.add(new Label(""));

    setLayout(new StackLayout(StackLayout.VERTICAL, 8));
    add("Top Wide Tall Flush", p1);
    add("Center Wide", p2);
    add("Center Wide", p3);
    add("Center Wide", p4);
    add("Bottom Wide", p5);	 
    
    pack();

  }

  /**
    * Is called whenever the user clicks a command button.
    */
  public boolean action(Event evt, Object what) {
    if (evt.target == setButton) {
      System.out.println("setButton pressed. Setting and reading the field values.");
      name = nameField.getText();
      org = orgField.getText();
      designation = designationField.getText(); 
      
      dispose();
      
      return true;
    }
    
    if (evt.target == cancelButton) {
      System.out.println("cancelButton pressed.");
      dispose();
      return true;
    }
    
    return false;
  }
  
        
  public String getName() {
    System.out.println("returning user name.");
    //dispose();
    //System.out.println("window disposed. returning modemOn status.");
    return name;    
  }

  public String getOrg() {
    System.out.println("returning user org.");
    //dispose();
    //System.out.println("window disposed. returning modemOn status.");
    return org;    
  }
  
  public String getDesignation() {
    System.out.println("returning user designation.");
    //dispose();
    //System.out.println("window disposed. returning modemOn status.");
    return designation;    
  }



}








