package bham.cs.fsc.exp;
import bham.cs.fsc.ui.*;
import bham.cs.fsc.gp.*;
//import gp.approx.ui.*;
import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Button;
import java.awt.Event;
import java.awt.Label;
import java.awt.Component;
import java.awt.Color;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.FileDialog;
import java.awt.Font;
import java.io.File;

/**
* 
* This is the modal dialog for loading a population and seed from a file when DGPClient is run as an application.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class SaveFileFrame extends Frame {
     
	private Button defaultButton;
	private Button cancelButton;
        private Button dialogButton;
        private TextArea fileLoadText;
        //private Label status;

        //DGPClient dgpClient;

        String popFileName;
        File popFile;
        GP g;
  
	public SaveFileFrame(GP g) {
	  setTitle("Save File");
	  //super(parent, new Rectangle(8, 8, 290, 110),
	  //			"Save File Dialog", true);
		//	Weird: The AWT is supposed to make the dialog window a child
		//	of the main frame. But it takes the desktop top left corner 
		//	as coordinate	origin instead of the frame's.
		//	On some systems, modal dialogs are fixed on the screen, therefore,
		//	I have to put my dialog near the top left corner, so that it is fully
		//	visible.
		//setResizable(false);
		setResizable(true);
		
		this.g = g;

		//this.dgpClient = dgpClient;
		
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		buttonPanel.setFont(new Font("Courier",Font.BOLD,11));
		defaultButton = new Button("Save to default file");
		buttonPanel.add("Tall Wide", defaultButton);
		dialogButton = new Button("Specify file");
		buttonPanel.add("Tall Wide", dialogButton);
		//buttonPanel.add("Tall Wide", new Panel());	// just as a spacer
		cancelButton = new Button("Cancel");
		buttonPanel.add("Tall Wide", cancelButton);

		Panel textPanel = new Panel();
		//textPanel.setLayout(new BorderLayout());
		textPanel.setLayout(new FlowLayout()); //default layout for panels
		textPanel.setFont(new Font("Courier",Font.PLAIN,11));
		fileLoadText = new TextArea("This run has been prematurely terminated. Please save the population and seed into a file so that you can continue the run from where it stopped the next time you invoke DGPClient. Click on the 'Save to default file' button to save population and seed into the default file 'GP.pop' or you may specify your own file name by clicking on the 'Specify file' button. If, however, you do not wish to save the population and seed, please click on the 'Cancel' button.",10,70,TextArea.SCROLLBARS_NONE);
		//fileLoadText.setFont("Courier",Font.Plain,11);
		fileLoadText.setEditable(false);
		//textPanel.add("Center", fileLoadText);
		textPanel.add(fileLoadText);

		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", textPanel);
		add("Bottom Wide", buttonPanel);	
	}

	/**
	* Is called whenever the user clicks a command button.
	*/
	public boolean action(Event evt, Object what) {
		if (evt.target == defaultButton) {
		  popFile = new File("GP.pop");
		  if (popFile.exists()) {
		    g.fileName = "GP.pop";
		    System.out.println("'Save to default file' button pressed. popFileName set to GP.pop.");
		    g.m.finished();
		    dispose();
		  }
	          return true;
		}
		
		if (evt.target == dialogButton) {
		  //Create a file dialog to query the user for a filename.
		  System.out.println("'Specify File' button pressed.");
		  FileDialog f = new FileDialog(this, "Save population to file", FileDialog.SAVE);
		  f.show();
		  popFileName = f.getFile(); 
		  popFile = new File(popFileName);
		  if (popFile.exists()) {
		    g.fileName = popFileName;	
		    System.out.println("'Specify File' button pressed. popFileName set to " + DGPClient.popFileName);
		    g.m.finished();
		    dispose();
		  }
		  return true;
		}

		if (evt.target == cancelButton) {
		  System.out.println("'Cancel' button pressed.");
		  g.fileName = null;
		  System.out.println("'Cancel' button pressed. popFileName set to null");
		  g.m.finished();
		  dispose();
		  return true;
		}
		return false;
	}

  // The handleEvent() method receives all events generated within the frame
	// window. You can use this method to respond to window events. To respond
	// to events generated by menus, buttons, etc. or other controls in the
	// frame window but not managed by the applet, override the window's
	// action() method.
	//--------------------------------------------------------------------------
	public boolean handleEvent(Event evt)
	{
		switch (evt.id)
		{
			// Application shutdown (e.g. user chooses Close from the system menu).
			//------------------------------------------------------------------
			case Event.WINDOW_DESTROY:
				// TODO: Place additional clean up code here
				dispose();
				System.exit(0);
				return true;

			default:
				return super.handleEvent(evt);
		}			 
	}

}








