package bham.cs.fsc.gp;

import java.io.*;

//import java.util.Hashtable;
//import java.util.Enumeration;
//import java.util.zip.*;    
import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;

//import bham.cs.fsc.gp.Individual;
//import bham.cs.fsc.gp.Program;
//import bham.cs.fsc.gp.Condition;

import bham.cs.fsc.*;

public class GPExpSettingsThread extends Thread  {

  int popSz; 
  int maxGen; 
  int expIntv; 
  int expNum;
  int impNum;
  int maxDepthNewIndv;
  int maxDepthAfterCrossover; 
  int maxDepthInMutants; 
  double crossOverProb; 
  double reprodProb;
  double mutationProb;
  String genMethod;
  String selMethod;
  String elitism;
  int tournamentSz;
  int fitnessCasesNum;
  String fitnessCases;
	
  int functionSetLength;
  int terminalSetLength;
	
  String[] functionSet;
  String[] terminalSet;

  SeedExpServlet p;
  

  public GPExpSettingsThread(SeedExpServlet parent) {
    super();
    this.p = parent;
  }


  public void run() {    
    
    PrintStream paramLog = null;
    try {
      paramLog = new PrintStream(new FileOutputStream(p.fileName));
      p.eventLog.println(p.getLogHeading(p.clientID) + "Client file created");
    }
    catch (IOException e) {
      p.eventLog.println(p.getLogHeading(p.ServletName) + "IOException when creating paramLog stream : " + e);
    }
    
    paramLog.println(p.getLogHeading(p.ServletName) + "Client IP Addr : " + p.clientIPAddr);
    p.eventLog.println(p.getLogHeading(p.clientID) + "Client IP Addr : " + p.clientIPAddr);
    paramLog.println(p.getLogHeading(p.ServletName) + "Client Host Name : " + p.clientHostName);
    p.eventLog.println(p.getLogHeading(p.clientID) + "Client Host Name : " + p.clientHostName);
    paramLog.println(p.getLogHeading(p.ServletName) + "Client Protocol : " + p.clientProtocol);
    p.eventLog.println(p.getLogHeading(p.clientID) + "Client Protocol : " + p.clientProtocol);
    paramLog.println(p.getLogHeading(p.ServletName) + "Seed used : " + p.seed);
    p.eventLog.println(p.getLogHeading(p.clientID) + "Seed used : " + p.seed);
    paramLog.println(p.getLogHeading(p.ServletName) + "Client ID : " + p.clientID);
    p.eventLog.println(p.getLogHeading(p.clientID) + "Client ID : " + p.clientID);
    p.eventLog.println(p.getLogHeading(p.clientID) + "Date and client header info written into client file.");
    
    
    //Reading parameters sent by client
    popSz = ((Integer)p.paramTable.get("Pop_Size")).intValue();
    maxGen = ((Integer)p.paramTable.get("Max_Gen")).intValue();
    expIntv = ((Integer)p.paramTable.get("Export_Interval")).intValue();
    expNum = ((Integer)p.paramTable.get("Export_Num")).intValue();
    impNum = ((Integer)p.paramTable.get("Import_Num")).intValue();
    maxDepthNewIndv = ((Integer)p.paramTable.get("Max_Depth_For_New_Indv")).intValue();
    maxDepthAfterCrossover = ((Integer)p.paramTable.get("Max_Depth_For_Indv_After_Crossover")).intValue();
    maxDepthInMutants = ((Integer)p.paramTable.get("Max_Depth_For_New_Subtrees_In_Mutants")).intValue();	 
    crossOverProb = ((Double)p.paramTable.get("Crossover_Prob")).doubleValue();
    reprodProb = ((Double)p.paramTable.get("Reproduction_Prob")).doubleValue();
    mutationProb = ((Double)p.paramTable.get("Mutation_Prob")).doubleValue();
    genMethod = (String)p.paramTable.get("Method_Of_Generation");
    selMethod = (String)p.paramTable.get("Method_Of_Selection");
    elitism = (String)p.paramTable.get("Elitism");
    tournamentSz = ((Integer)p.paramTable.get("Tournament_selection_group_size")).intValue();
    fitnessCasesNum = ((Integer)p.paramTable.get("Fitness_Cases_Num")).intValue();
    fitnessCases = (String)p.paramTable.get("Fitness_Cases");
    
    functionSetLength = ((Integer)p.paramTable.get("Function_Set_length")).intValue();
    terminalSetLength = ((Integer)p.paramTable.get("Terminal_Set_length")).intValue();
    
    functionSet = new String[functionSetLength];
    terminalSet = new String[terminalSetLength];

    for (int i=0; i < functionSetLength; i++) {
      functionSet[i] = (String)p.paramTable.get("Function_Set_" + i);
    }
    
    for (int j=0; j < terminalSetLength; j++) {
      terminalSet[j] = (String)p.paramTable.get("Terminal_Set_" + j);
    }
	
    //Writing the parameters into client's session file
    paramLog.println(p.getLogHeading(p.ServletName) + "Pop_Size" + " : " + popSz);
    paramLog.println(p.getLogHeading(p.ServletName) + "Max_Gen" + " : " + maxGen);
    paramLog.println(p.getLogHeading(p.ServletName) + "Export_Interval" + " : " + expIntv);
    paramLog.println(p.getLogHeading(p.ServletName) + "Export_Num" + " : " + expNum);
    paramLog.println(p.getLogHeading(p.ServletName) + "Import_Num" + " : " + impNum);
    paramLog.println(p.getLogHeading(p.ServletName) + "Max_Depth_For_New_Indv" + " : " + maxDepthNewIndv);
    paramLog.println(p.getLogHeading(p.ServletName) + "Max_Depth_For_Indv_After_Crossover" + " : " + maxDepthAfterCrossover);
    paramLog.println(p.getLogHeading(p.ServletName) + "Max_Depth_For_New_Subtrees_In_Mutants" + " : " + maxDepthInMutants);
    paramLog.println(p.getLogHeading(p.ServletName) + "Crossover_Prob" + " : " + crossOverProb);
    paramLog.println(p.getLogHeading(p.ServletName) + "Reproduction_Prob" + " : " + reprodProb);
    paramLog.println(p.getLogHeading(p.ServletName) + "Mutation_Prob" + " : " + mutationProb);
    paramLog.println(p.getLogHeading(p.ServletName) + "Method_Of_Generation" + " : " + genMethod);
    paramLog.println(p.getLogHeading(p.ServletName) + "Method_Of_Selection" + " : " + selMethod);
    paramLog.println(p.getLogHeading(p.ServletName) + "Elitism" + " : " + elitism);
    paramLog.println(p.getLogHeading(p.ServletName) + "Tournament_selection_group_size" + " : " + tournamentSz);
    paramLog.println(p.getLogHeading(p.ServletName) + "Fitness_Cases_Num" + " : " + fitnessCasesNum);
    paramLog.println(p.getLogHeading(p.ServletName) + "Fitness_Cases" + " : " + fitnessCases);
    
    paramLog.print(p.getLogHeading(p.ServletName) + "Function_Set" + " : ");
    for (int k=0; k < functionSetLength; k++) {
      paramLog.print(functionSet[k] + "   ");
    }
    paramLog.println("\n");
    
    paramLog.print(p.getLogHeading(p.ServletName) + "Terminal_Set" + " : ");
    for (int m=0; m < terminalSetLength; m++) {
      paramLog.print(terminalSet[m] + "   ");
    }
    paramLog.println("\n");  
    
    //write status to log 
    p.eventLog.println(p.getLogHeading(p.clientID) + "GP settings received from client written to client file.");
    paramLog.flush();
    paramLog.close();
    p.eventLog.println(p.getLogHeading(p.clientID) + "client file written and closed.");


    p.eventLog.println(p.getLogHeading(p.clientID) + "Incrementing counters according to whether solution is found.");

    //classifyAndCount settings for the run where a solution is found.
					    
    synchronized (p.settingsTable) {
    classifyAndCount(p.popSz_Array, popSz, 100, 300, 500);
    classifyAndCount(p.maxGen_Array, maxGen, 10, 30, 50);
    classifyAndCount(p.expIntv_Array, expIntv, 10, 20, 30);
    classifyAndCount(p.expNum_Array, expNum, 4, 7, 0);
    classifyAndCount(p.impNum_Array, impNum, 4, 7, 0);
    classifyAndCount(p.maxDepthNewIndv_Array, maxDepthNewIndv, 4, 6, 0);
    classifyAndCount(p.maxDepthAfterCrossover_Array, maxDepthAfterCrossover, 10, 15, 0);
    classifyAndCount(p.maxDepthInMutants_Array, maxDepthInMutants, 3, 5, 0);
    classifyAndCount(p.tournamentSz_Array, tournamentSz, 5, 10, 15);
    classifyAndCountDouble(p.crossOverProb_Array, crossOverProb, 30.0, 70.0, 0.0);
    classifyAndCountDouble(p.reprodProb_Array, reprodProb, 30.0, 70.0, 0.0);
    classifyAndCountDouble(p.mutationProb_Array, mutationProb, 30.0, 70.0, 0.0);
    classifyAndCountGenMethod(p.genMethod_Array,  genMethod);
    classifyAndCountSelMethod(p.selMethod_Array, selMethod);
    classifyAndCountElitism(p.elitism_Array, elitism);
    
    p.eventLog.println(p.getLogHeading(p.clientID) + "Completed classifying and incrementing counters for GP settings arrays.");

    p.printStatReport(p.eventLog);

    p.updateGPSettingsFile();
    p.eventLog.println(p.getLogHeading(p.clientID) + "GPSettingsFile updated.");
    }
  }    
    

  void classifyAndCount(int[] iArray, int item, int r1, int r2, int r3) {
    boolean notDone = true;
    int i = 0;
    int[] rArray = {r1, r2, r3};
    int num;

    //*if (iArray.length == (rArray.length + 1)) {
      //p.eventLog.println(p.getLogHeading(clientID) + "Matched number of array elements and range intervals.");
      while ((notDone) && (i < iArray.length -1) && (i < rArray.length)) {
	if (item <= rArray[i]) {
	  synchronized (iArray) {
	    iArray[i] ++;  
	  }
	  notDone = false;
	}
	i++;
      }

      if (notDone) {
	if (item > rArray[i-1]) {
	  synchronized (iArray) {
	    iArray[iArray.length -1] ++;
	  }
	  notDone = false;
	}
      }
      //*}
      /*
    else {
      p.eventLog.println(p.getLogHeading(clientID) + "Unmatched number of array elements and range intervals.");
    }
    */
  }


  void classifyAndCountDouble(int[] dArray, double item, double d1, double d2, double d3) {
    boolean notDone = true;
    int i = 0;
    double[] rArray = {d1, d2, d3};
    int num;

    //*if (dArray.length == (rArray.length + 1)) {
      //p.eventLog.println(p.getLogHeading(clientID) + "Matched number of array elements and range intervals.");
      while ((notDone) && (i < dArray.length -1) && (i < rArray.length)) {
	if (item <= rArray[i]) {
	  synchronized (dArray) {
	    dArray[i] ++;  
	  }
	  notDone = false;
	}
	i++;
      }

      if (notDone) {
	if (item > rArray[i-1]) {
	  synchronized (dArray) {
	    dArray[dArray.length -1] ++;
	  }
	  notDone = false;
	}
      }
      //*}
      /*
    else {
      p.eventLog.println(p.getLogHeading(clientID) + "Unmatched number of array elements and range intervals.");
    }
    */
  }

  
  void classifyAndCountGenMethod(int[] genMethodArray, String solGenMethod) {
    if (solGenMethod.equalsIgnoreCase("Grow")) {
      synchronized (genMethodArray) {
	genMethodArray[0] ++;
      }
    }
    else 
      if (solGenMethod.equalsIgnoreCase("Full")) {
	synchronized (genMethodArray) {
	  genMethodArray[1] ++;
	}
      }
      else 
	if (solGenMethod.equalsIgnoreCase("Ramped half and half")) {
	  synchronized (genMethodArray) {
	    genMethodArray[2] ++;
	  }
	}
  }


  void classifyAndCountSelMethod(int[] selMethodArray, String solSelMethod) {
    if (solSelMethod.equalsIgnoreCase("Fitness proportionate")) {
      synchronized (selMethodArray) {
	selMethodArray[0] ++;
      }
    }
    else 
      if (solSelMethod.equalsIgnoreCase("Tournament")) {
	synchronized (selMethodArray) {
	  selMethodArray[1] ++;
	}
      }
  }


  
  void classifyAndCountElitism(int[] elitismArray, String elitismString) {
    if (elitismString.equalsIgnoreCase("Yes")) {
      synchronized (elitismArray) {
	elitismArray[0] ++;
      }
    }
    else 
      if (elitismString.equalsIgnoreCase("No")) {
	synchronized (elitismArray) {
	  elitismArray[1] ++;
	}
      }
  }

} //end of class
