package bham.cs.fsc.gp;

import bham.cs.fsc.exp.*;
import bham.cs.fsc.ui.*;
//import gp.approx.ui.*;
import java.awt.Component;
import java.awt.Panel;
import java.awt.Image;

/**
* This interface is for implementation of the problem specific codes.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public interface Problem {
  
  //public TrailPlot plot; 
  //public TrailUI fitnessCases;
  
  //public XYPlot plot;
  //public PointsUI fitnessCases;

  //public String fitnessCaseString;
  //public int NrOfFitnessCases;

  //public boolean maxHits = false;

  public String getProblemName();
  public Panel defPlotPanel(DGPClient dgpc);  
  //public UPlot getPlot();
  public Plot getPlot();
  //public String getGraphicsLabel();
  //public XYPlot getGraphics();
  public SetUI getTerminalSet();
  public SetUI getFunctionSet();
  //public void fitnessFunction(Individual ind, GP gp, int individualNr);
  public boolean fitnessFunction(Individual ind, GP gp, int individualNr);
  public double[] getFitnessesOfAllIndividuals(Individual[] population);
  public void evalBestOfRunIndividual(Individual ind, GP gp);
  //public RealPoint[] fitnessCurve(Individual ind, GP gp);
  public void normalizeFitnessOfPopulation(Individual[] population);
  public void makeDefaultFitnessCases();
  public PlotUI getFitnessCases();
  public String getFitnessCaseString();
  public int getNrOfFitnessCases();
  public void initMaxHits();
  public boolean getMaxHits();
  public String getFitnessType();
  //public void setPWindow();
  public Histogram createHistogram();
  public FrameConstraint getPlotFrameConstraint();
  public FrameConstraint getHistoFrameConstraint();
  //public boolean terminationPredicate();
  public Image[] getImageArray();
}







