package bham.cs.fsc.gp;

import java.io.*;

//import java.util.Hashtable;
//import java.util.Enumeration;
//import java.util.zip.*;    
import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;

//import bham.cs.fsc.gp.Individual;
//import bham.cs.fsc.gp.Program;
//import bham.cs.fsc.gp.Condition;

import bham.cs.fsc.*;

public class ResultsThread extends Thread  {

  //boolean solFound;
  int endGen;
  //int maxGen;
  boolean prematureEnd;
  int nrOfFoodEaten;

  //Individual solutionIndv;
  String solutionIndv;

  String solUserName;
  String solUserOrg;
  String solUserDesignation;

  int solPopSz; 
  int solMaxGen; 
  int solExpIntv; 
  int solExpNum;
  int solImpNum;
  int solMaxDepthNewIndv;
  int solMaxDepthAfterCrossover; 
  int solMaxDepthInMutants; 
  double solCrossOverProb; 
  double solReprodProb;
  double solMutationProb;
  String solGenMethod;
  String solSelMethod;
  String solElitism;
  int solTournamentSz;

  String clientID;
  Stat10Servlet p;
  StringBuffer sb;
  String fileName;
  
  public static final int nrOfSantaFeFoodPellets = 89; 


  public ResultsThread(Stat10Servlet parent) {
    super();
    this.p = parent;
  }


  public void run() {    
    // read in the servlet's parameters 
    String clientQueryString = p.req.getQueryString();
    String clientProbName = clientQueryString.substring(clientQueryString.indexOf("=") + 1);
    String clientIPAddr = p.req.getRemoteAddr();
    String clientHostName = p.req.getRemoteHost();
    String clientProtocol = p.req.getProtocol();
    
    if ((clientProbName != null) && (clientProbName.trim()).equals(p.currentProblem.trim())) {
      
      p.eventLog.println(p.getLogHeading(p.clientID) + "clientProbName not null and equals to " + p.currentProblem);
      
      //p.clientID = (String)p.endOfRunTable.get("ClientID");
      this.clientID = p.clientID;
      //solFound = ((Boolean)p.endOfRunTable.get("SolFound")).booleanValue();
      endGen = ((Integer)p.endOfRunTable.get("EndGen")).intValue();

      if (p.solFound) {
	//synchronized (p.solClientIDsb) {
	p.solClientIDsb.append("ClientID : " + clientID + "\n");
	  //}	

	p.updateSolClientIDFile();
	p.eventLog.println(p.getLogHeading(clientID) + "Solution found. ClientID which found solution is updated into the solClientID file.");

	solUserName = (String)p.endOfRunTable.get("UserName");
	solUserOrg = (String)p.endOfRunTable.get("UserOrg");
	solUserDesignation = (String)p.endOfRunTable.get("UserDesignation");

	//p.eventLog.println(p.getLogHeading(clientID) + "User info received.");
	
	//solutionIndv = (Individual)p.endOfRunTable.get("Solution");
	solutionIndv = (String)p.endOfRunTable.get("Solution");
	//p.eventLog.println(p.getLogHeading(clientID) + "Solution received");
	solPopSz = ((Integer)p.endOfRunTable.get("Pop_Size")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "popSz received");
	solMaxGen = ((Integer)p.endOfRunTable.get("Max_Gen")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "maxgen received");
	solExpIntv = ((Integer)p.endOfRunTable.get("Export_Interval")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "exportInt received");
	solExpNum = ((Integer)p.endOfRunTable.get("Export_Num")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "exportnum received");
	solImpNum = ((Integer)p.endOfRunTable.get("Import_Num")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "importnum received");
	solMaxDepthNewIndv = ((Integer)p.endOfRunTable.get("Max_Depth_For_New_Indv")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "max depth for new indv received");
	solMaxDepthAfterCrossover = ((Integer)p.endOfRunTable.get("Max_Depth_For_Indv_After_Crossover")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "max depth after crossover received");
	solMaxDepthInMutants = ((Integer)p.endOfRunTable.get("Max_Depth_For_New_Subtrees_In_Mutants")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "max depth in mutants received");
	solCrossOverProb = ((Double)p.endOfRunTable.get("Crossover_Prob")).doubleValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "crossover prob received");
	solReprodProb = ((Double)p.endOfRunTable.get("Reproduction_Prob")).doubleValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "reprod prob received");
	solMutationProb = ((Double)p.endOfRunTable.get("Mutation_Prob")).doubleValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "mutation prob received");
	solGenMethod = (String)p.endOfRunTable.get("Method_Of_Generation");
	//p.eventLog.println(p.getLogHeading(clientID) + "gen method received");
	solSelMethod = (String)p.endOfRunTable.get("Method_Of_Selection");
	//p.eventLog.println(p.getLogHeading(clientID) + "sel method received");
	solElitism = (String)p.endOfRunTable.get("Elitism");
	solTournamentSz = ((Integer)p.endOfRunTable.get("Tournament_selection_group_size")).intValue();
	//p.eventLog.println(p.getLogHeading(clientID) + "tournament size received");
      }
      else {
	//maxGen = ((Integer)p.endOfRunTable.get("MaxGen")).intValue();
	prematureEnd = ((Boolean)p.endOfRunTable.get("Sudden_End")).booleanValue();
	nrOfFoodEaten = ((Integer)p.endOfRunTable.get("FoodEaten")).intValue();
      }

      p.eventLog.println(p.getLogHeading(clientID) + "All parameters sent by client read by servlet");
      p.eventLog.println(p.getLogHeading(clientID) + "Updating results into client file.");

      fileName = p.servletLogDir + p.currentProblem + "." +  clientID + ".params";
      p.eventLog.println(p.getLogHeading(clientID) + "Client's file name : " + fileName);
	
      BufferedReader d = null;
      String line = "";
      sb = new StringBuffer();
      boolean fileFound = true;
	
      try {
	d = new BufferedReader(new FileReader(fileName));
	p.eventLog.println(p.getLogHeading(clientID) + "Reading contents from client file");
      } 
      catch(FileNotFoundException e) {
	  //file should have been created when client requests for seed. If client failed to receive seed, it will use the default seed 12345 and will run standalone without exchange of individuals.
	p.eventLog.println(p.getLogHeading(clientID) + "client file not found !!!");
	fileFound = false;
      }
	
      if (fileFound) {
	boolean cont = true ;
	while (cont == true) {
	  try {
	    line = (d.readLine()) ;
	  } catch(IOException e) {
	    p.eventLog.println(p.getLogHeading(clientID) + "readLine for Client file error: " + e);
	    cont = false ;
	  }
	  if (line != null) {
	    //eventLog.println(getLogHeading(clientID) + line);
	    sb.append(line + "\n");	    
	  } 
	  else {
	    //eventLog.println(getLogHeading(clientID) + "line is null");
	    cont = false;
	  }
	}
      }

      
      p.eventLog.println(p.getLogHeading(clientID) + "Incrementing counters according to whether solution is found.");

      synchronized (p.resultsTable) {
      if (! p.solFound) {
	synchronized (p.nrOfNoSolFoundObj) {
	  p.nrOfNoSolFoundObj = incrementCount(p.nrOfNoSolFoundObj);
	  p.eventLog.println(p.getLogHeading(clientID) + "nrOfNoSolFound incremented to " + p.nrOfNoSolFoundObj.intValue());
	}

	sb.append("*** Solution NOT found in this run ! ***\n");
	
	//if (endGen == maxGen) {
	if (! prematureEnd) {
	  sb.append("Run completed\n");

	  synchronized (p.nrOfRunCompletedObj) {
	    p.nrOfRunCompletedObj = incrementCount(p.nrOfRunCompletedObj);
	    p.eventLog.println(p.getLogHeading(clientID) + "nrOfRunCompleted incremented to " + p.nrOfRunCompletedObj.intValue());
	  }

	  classifyAndCount(p.endGenOfCompletedRun, endGen, 10, 30, 50);
	  p.eventLog.println(p.getLogHeading(clientID) + "endGenOfCompletedRun classified and incremented.");
	  //classifyAndCount(p.completeRunFoodEaten, nrOfFoodEaten, 20, 60, 89);
	  classifyAndCount(p.completeRunFoodEaten, nrOfFoodEaten, 30, 60, 80);
	  p.eventLog.println(p.getLogHeading(clientID) + "nrOfFoodEaten for completed run classified and incremented.");
	}
	else {
	  sb.append("!! Run was terminated prematurely !!\n");

	  synchronized (p.nrOfRunNotCompletedObj) {
	    p.nrOfRunNotCompletedObj = incrementCount(p.nrOfRunNotCompletedObj);
	    p.eventLog.println(p.getLogHeading(clientID) + "nrOfRunNotCompleted incremented to " + p.nrOfRunNotCompletedObj.intValue());
	  }

	  classifyAndCount(p.endGenOfUncompletedRun, endGen, 10, 30, 50);
	  p.eventLog.println(p.getLogHeading(clientID) + "endGenOfUnCompletedRun classified and incremented.");
	  //classifyAndCount(p.uncompletedRunFoodEaten, nrOfFoodEaten, 20, 60, 89);
	  classifyAndCount(p.uncompletedRunFoodEaten, nrOfFoodEaten, 30, 60, 80);
	  p.eventLog.println(p.getLogHeading(clientID) + "nrOfFoodEaten for uncompleted run classified and incremented.");
	}
	
	sb.append("Run ends at generation " + endGen + "\n");
	sb.append("Number of food pellets eaten : " + nrOfFoodEaten + "\n");
      }
      else {
	synchronized (p.nrOfSolFoundObj) {
	  p.nrOfSolFoundObj = incrementCount(p.nrOfSolFoundObj);
	  p.eventLog.println(p.getLogHeading(clientID) + "nrOfSolFound incremented to " + p.nrOfSolFoundObj.intValue());
	}
	
	synchronized (p.nrOfRunCompletedObj) {
	  p.nrOfRunCompletedObj = incrementCount(p.nrOfRunCompletedObj);	
	  p.eventLog.println(p.getLogHeading(clientID) + "nrOfRunCompleted(solFound) incremented to " + p.nrOfRunCompletedObj.intValue());
	}

	//classifyAndCount(p.completeRunFoodEaten, nrOfSantaFeFoodPellets, 20, 60, 89);
	classifyAndCount(p.completeRunFoodEaten, nrOfSantaFeFoodPellets, 30, 60, 80);
	p.eventLog.println(p.getLogHeading(clientID) + "nrOfFoodEaten for completed run classified and incremented.");
	
	classifyAndCount(p.genOfSolFound, endGen, 10, 30, 50);
	p.eventLog.println(p.getLogHeading(clientID) + "genOfSolFound classified and incremented.");
	
	synchronized (p.settingsTable) {
	//classifyAndCount settings for the run where a solution is found.
	classifyAndCount(p.popSz_Array, solPopSz, 100, 300, 500);
	classifyAndCount(p.maxGen_Array, solMaxGen, 10, 30, 50);
	classifyAndCount(p.expIntv_Array, solExpIntv, 10, 20, 30);
	//classifyAndCount(p.expNum_Array, solExpNum, 1, 5, 0);
	classifyAndCount(p.expNum_Array, solExpNum, 4, 7, 0);
	//classifyAndCount(p.impNum_Array, solImpNum, 1, 5, 0);
	classifyAndCount(p.impNum_Array, solImpNum, 4, 7, 0);
	//classifyAndCount(p.maxDepthNewIndv_Array, solMaxDepthNewIndv, 1, 5, 0);
	classifyAndCount(p.maxDepthNewIndv_Array, solMaxDepthNewIndv, 4, 6, 0);
	//classifyAndCount(p.maxDepthAfterCrossover_Array, solMaxDepthAfterCrossover, 5, 10, 0);
	classifyAndCount(p.maxDepthAfterCrossover_Array, solMaxDepthAfterCrossover, 10, 15, 0);
	//classifyAndCount(p.maxDepthInMutants_Array, solMaxDepthInMutants, 1, 5, 0);
	classifyAndCount(p.maxDepthInMutants_Array, solMaxDepthInMutants, 3, 5, 0);
	classifyAndCount(p.tournamentSz_Array, solTournamentSz, 5, 10, 15);
	//classifyAndCountDouble(p.crossOverProb_Array, solCrossOverProb, 10.0, 50.0, 0.0);
	classifyAndCountDouble(p.crossOverProb_Array, solCrossOverProb, 30.0, 70.0, 0.0);
	//classifyAndCountDouble(p.reprodProb_Array, solReprodProb, 10.0, 50.0, 0.0);
	classifyAndCountDouble(p.reprodProb_Array, solReprodProb, 30.0, 70.0, 0.0);
	//classifyAndCountDouble(p.mutationProb_Array, solMutationProb, 10.0, 50.0, 0.0);
	classifyAndCountDouble(p.mutationProb_Array, solMutationProb, 30.0, 70.0, 0.0);
	classifyAndCountGenMethod(p.genMethod_Array,  solGenMethod);
	classifyAndCountSelMethod(p.selMethod_Array, solSelMethod);
	classifyAndCountElitism(p.elitism_Array, solElitism);
	
	p.eventLog.println(p.getLogHeading(clientID) + "Completed classifying and incrementing counters for GP settings arrays.");
	
	//convert individual into a string and write it with other results to the client file.
	sb.append("*** Solution found in this run ! ***\n");
	sb.append("Solution is found in generation " + endGen + "\n");
	sb.append("Solution is :\n");
	//sb.append(solutionIndv.toString() + "\n");
	sb.append(solutionIndv + "\n");
	sb.append("\nSolution is found by :\n");
	sb.append("Name : " + solUserName + "\n");
	sb.append("Organisation : " + solUserOrg + "\n");
	sb.append("Designation : " + solUserDesignation + "\n");
	} //end of synchronized settingsTable	
      } //else solfound

      p.printStatReport(p.eventLog);

      //saving files
      p.updateSolSettingsFile();
      p.eventLog.println(p.getLogHeading(clientID) + "solSettingsFile updated.");
      p.updateResultsFile();
      p.eventLog.println(p.getLogHeading(clientID) + "resultsFile updated.");
      
      } //end of synchronized resultsTable

      String clientLogString = sb.toString();
      p.eventLog.println(p.getLogHeading(clientID) + "string buffer for client converted to string");
      try {
	PrintStream clientLog = new PrintStream(new FileOutputStream(fileName));
	p.eventLog.println(p.getLogHeading(clientID) + "client file " + fileName + " found and opened.");
	clientLog.println(clientLogString);
	p.eventLog.println(p.getLogHeading(clientID) + "buffer string written to client file");
	clientLog.flush();
      clientLog.close();
      p.eventLog.println(p.getLogHeading(clientID) + "client file flushed and closed");
      }
      catch (IOException e) {
	p.eventLog.println(p.getLogHeading(clientID) + "IOException when writing to output stream for client file : " + e);
      }
      
    }
    else {
      p.eventLog.println(p.getLogHeading(clientID) + "Problem name does not match.");
    }
    
    //start thread to print the statistics report.
    //***p.eventLog.println(p.getLogHeading(clientID) + "Starting thread to print statistics report before servlet is destroyed.");
    //***ReportThread pThread = new ReportThread(p); 
    //***pThread.start();
    //***p.eventLog.println(p.getLogHeading(clientID) + "Thread to print statistics report started.");
    
    /*
    p.eventLog.println("\n");
    printIntArray(p.popSz_Array, "Population Sizes");
    printIntArray(p.maxGen_Array, "Max Gens");
    printIntArray(p.expIntv_Array, "Export Intervals");
    printIntArray(p.expNum_Array, "Num to export");
    printIntArray(p.impNum_Array, "Num to import");
    printIntArray(p.maxDepthNewIndv_Array, "Max depth for new individual");
    printIntArray(p.maxDepthAfterCrossover_Array, "Max depth for individuals after crossover");
    printIntArray(p.maxDepthInMutants_Array, "Max depth for individuals in mutants");
    printIntArray(p.crossOverProb_Array, "Cross over probabilities");
    printIntArray(p.reprodProb_Array, "Reproduction probabilities");
    printIntArray(p.mutationProb_Array, "Mutation probabilities");
    printIntArray(p.genMethod_Array, "Generation Methods");
    printIntArray(p.selMethod_Array, "Selection Methods");
    printIntArray(p.tournamentSz_Array, "Tournament Selection group sizes");
    
    printIntObj(p.nrOfSolFoundObj, "Num of runs with solution found");
    printIntObj(p.nrOfNoSolFoundObj, "Num of runs with no solution found");
    printIntObj(p.nrOfRunCompletedObj, "Num of runs which are completed");
    printIntObj(p.nrOfRunNotCompletedObj, "Num of runs terminated prematurely");

    printIntArray(p.endGenOfCompletedRun, "Gen Num where run completes");
    printIntArray(p.endGenOfUncompletedRun, "Gen Num where run was prematurely terminated");
    printIntArray(p.completeRunFoodEaten, "Num of food pellets eaten in a completed run");
    printIntArray(p.uncompletedRunFoodEaten, "Num of food pellets eaten in a run which was terminated prematurely");
    printIntArray(p.genOfSolFound, "Gen Num of run in which a solution was found");

    p.eventLog.println(p.getLogHeading(p.ServletName) + "statistical report printed.");
    */

    //p.updateSolSettingsFile();
    //p.updateResultsFile();
    //updateLogFile();
    
  }  
    
  
  Integer incrementCount(Integer intObj) {
    int num;
    synchronized (intObj) {
      num = intObj.intValue();
      //p.eventLog.println(p.getLogHeading(clientID) + "initial value of Integer obj : " + num);
      num ++;
      //p.eventLog.println(p.getLogHeading(clientID) + "incremented value of Integer obj : " + num);
      intObj = new Integer(num);
      //p.eventLog.println(p.getLogHeading(clientID) + "Integer obj updated to : " +  intObj.intValue());
      return intObj;
    }
  }


  void classifyAndCount(int[] iArray, int item, int r1, int r2, int r3) {
    boolean notDone = true;
    int i = 0;
    int[] rArray = {r1, r2, r3};
    int num;

    //*if (iArray.length == (rArray.length + 1)) {
      //p.eventLog.println(p.getLogHeading(clientID) + "Matched number of array elements and range intervals.");
      while ((notDone) && (i < iArray.length -1) && (i < rArray.length)) {
	if (item <= rArray[i]) {
	  synchronized (iArray) {
	    iArray[i] ++;  
	  }
	  notDone = false;
	}
	i++;
      }

      if (notDone) {
	if (item > rArray[i-1]) {
	  synchronized (iArray) {
	    iArray[iArray.length -1] ++;
	  }
	  notDone = false;
	}
      }
      //*}
      /*
    else {
      p.eventLog.println(p.getLogHeading(clientID) + "Unmatched number of array elements and range intervals.");
    }
    */
  }


  void classifyAndCountDouble(int[] dArray, double item, double d1, double d2, double d3) {
    boolean notDone = true;
    int i = 0;
    double[] rArray = {d1, d2, d3};
    int num;

    //*if (dArray.length == (rArray.length + 1)) {
      //p.eventLog.println(p.getLogHeading(clientID) + "Matched number of array elements and range intervals.");
      while ((notDone) && (i < dArray.length -1) && (i < rArray.length)) {
	if (item <= rArray[i]) {
	  synchronized (dArray) {
	    dArray[i] ++;  
	  }
	  notDone = false;
	}
	i++;
      }

      if (notDone) {
	if (item > rArray[i-1]) {
	  synchronized (dArray) {
	    dArray[dArray.length -1] ++;
	  }
	  notDone = false;
	}
      }
      //*}
      /*
    else {
      p.eventLog.println(p.getLogHeading(clientID) + "Unmatched number of array elements and range intervals.");
    }
    */
  }

  
  void classifyAndCountGenMethod(int[] genMethodArray, String solGenMethod) {
    if (solGenMethod.equalsIgnoreCase("Grow")) {
      synchronized (genMethodArray) {
	genMethodArray[0] ++;
      }
    }
    else 
      if (solGenMethod.equalsIgnoreCase("Full")) {
	synchronized (genMethodArray) {
	  genMethodArray[1] ++;
	}
      }
      else 
	if (solGenMethod.equalsIgnoreCase("Ramped half and half")) {
	  synchronized (genMethodArray) {
	    genMethodArray[2] ++;
	  }
	}
  }


  void classifyAndCountSelMethod(int[] selMethodArray, String solSelMethod) {
    if (solSelMethod.equalsIgnoreCase("Fitness proportionate")) {
      synchronized (selMethodArray) {
	selMethodArray[0] ++;
      }
    }
    else 
      if (solSelMethod.equalsIgnoreCase("Tournament")) {
	synchronized (selMethodArray) {
	  selMethodArray[1] ++;
	}
      }
  }


  void classifyAndCountElitism(int[] elitismArray, String elitismString) {
    if (elitismString.equalsIgnoreCase("Yes")) {
      synchronized (elitismArray) {
	elitismArray[0] ++;
      }
    }
    else 
      if (elitismString.equalsIgnoreCase("No")) {
	synchronized (elitismArray) {
	  elitismArray[1] ++;
	}
      }
  }

  /*
  void printIntArray(int[] iArray, String heading) {
    if ((iArray != null) && (iArray.length != 0)) {
      p.eventLog.print(p.getLogHeading(clientID) + heading + " : ");
      for (int i = 0; i < iArray.length; i++) {	
	p.eventLog.print(iArray[i] + "    ");
      }
      p.eventLog.println("");
    }
    else {
      p.eventLog.println(p.getLogHeading(clientID) + heading + " is null or empty.");
    }    
  }
  
  
  void printIntObj(Integer intObj, String heading) {
    if (intObj != null) {
      p.eventLog.print(p.getLogHeading(clientID) + heading + " : ");
      p.eventLog.println(intObj.intValue());
    }
    else {
      p.eventLog.println(p.getLogHeading(clientID) + heading + " is null.");
    }
  }  
  */

} //end of class
