package bham.cs.fsc.gp.ant;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.ui.*;

public class Move extends Terminal implements Serializable {
  
        PlotData[] antPosArray;

  public Move() {}
  
	public String toString(int level) {
		return Program.indent(level) + "(MOVE)";
	}

	protected Object clone() {
		return new Move(); 
	}


	public String getName() {
		return "(MOVE)";
	}

        //public double eval(double gridLimit) {
	public double eval(double x) {  

	  //System.out.println("Evaluating Move ");
	  
	  /*stopEval checking is not required because either no terminals are evaluated before this or checking would 
	  have been done at the PROGNx preceding this function.*/

	  //if (! Ant.stopEval()) {

	  //**System.out.println("Ant facing " + Ant.facing);
	  //**System.out.println("Ant's current position : " + Ant.X + "," + Ant.Y);
	    
	    switch (Ant.facing) {

	    case Ant.NORTH :
	      //**System.out.println("in North. --- reduce Y by 1");
	      //Ant.Y = Ant.getNewYCoordinate(Ant.Y - 1, gridLimit);
	      Ant.Y = Ant.getNewYCoordinate(Ant.Y - 1);
	      break;

	    case Ant.SOUTH :
	      //**System.out.println("in South. --- increase Y by 1"); 
	      //Ant.Y = Ant.getNewYCoordinate(Ant.Y + 1, gridLimit);
	      Ant.Y = Ant.getNewYCoordinate(Ant.Y + 1);
	      break;
	    
	    case Ant.EAST :
	      //**System.out.println("in East. --- increase X by 1");
	      //Ant.X = Ant.getNewXCoordinate(Ant.X + 1, gridLimit);
	      Ant.X = Ant.getNewXCoordinate(Ant.X + 1);
	      break;

	    case Ant.WEST :
	      //**System.out.println("in West. --- decrease X by 1");
	      //Ant.X = Ant.getNewXCoordinate(Ant.X - 1, gridLimit);
	      Ant.X = Ant.getNewXCoordinate(Ant.X - 1);
	      break;
	    }

	    //**System.out.println("Ant's new position after move : " + Ant.X + "," + Ant.Y);
	    
	    if (Ant.food[Ant.X][Ant.Y]) {
	      //**System.out.println("Ant's new position has food.");
	      //**System.out.println("original no. of food eaten is " + Ant.foodEaten);
	      //**System.out.println("*** food is eaten ***");
	      Ant.foodEaten ++;
	      //**System.out.println("no. of food eaten is " + Ant.foodEaten);
	      Ant.food[Ant.X][Ant.Y] = false;
	    }
	    
	    Ant.timeSteps = Ant.timeSteps - 1;

	    //if (Ant.recAntPos) {
	    //System.out.println("Recording Ant Move position (" + Ant.trailArrayIndex + " ) : " + Ant.X + "," + Ant.Y);
	    Ant.bestTrail[Ant.trailArrayIndex] = new RealPoint((double)Ant.X, (double)Ant.Y);
	    Ant.trailArrayIndex ++;
	    //}
	    if (Ant.gp.evalBest) {
	      if (Ant.drawAnt()) {
		antPosArray = new RealPoint[1];
		antPosArray[0] = new RealPoint((double)Ant.X, (double)Ant.Y);
		
		//System.out.println("Plotting new Ant position : " + (double)Ant.X + "," + (double)Ant.Y);
		
		Ant.gp.notifyObservers(new GPMessageEvaluatingIndividual(antPosArray));
	      }
	    }
	    //}
	    return 1.0;
	}

}



