package bham.cs.fsc.gp.ant;

import java.io.*;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.ui.*;
//import gp.ant.ui.*;
//import gp.approx.ui.*;

/**
* Problem specific code to demonstrate the solving of the Artificial Ant problem.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/

//public class SantaFe extends Ant implements Problem {
public class SantaFe extends Ant {
  //public TrailPlot plot; 
  //public XYPlot plot;
  //public UPlot plot;
  //public TrailUI fitnessCases;
  //public PointsUI fitnessCases;
  //public PlotUI fitnessCases;
  //public String fitnessCaseString;
  //public int NrOfFitnessCases = 1;
  //public boolean maxHits = false;


  //static int timeSteps;  
  //static int foodEaten;
  //static int XCoordinate;
  //static int YCoordinate;
  //static String facing;
  
  //boolean [][] food;

  final int numFoodPieces = 89;
  final int gridSize = 32;  
  final String panelName = "Santa Fe Trail";
  //final int probTimeSteps = 400;
  final int probTimeSteps = 600;

  public SantaFe() { 
    Ant.numFoodPieces = this.numFoodPieces;
    Ant.gridSize = this.gridSize;
    Ant.panelName = this.panelName;
    Ant.probTimeSteps = this.probTimeSteps;
}

  /*
  public String getProblemName() {
    return "Artificial Ant"; 
  }
  */
  /*  
 public Panel defPlotPanel() {
   return plotPanel("Santa Fe Trail");
 }
 */
  /*
    Panel plotPanel = new Panel();
    plotPanel.setLayout(new BorderLayout());
    //String probLabel = prob.getGraphicsLabel();
    //plotPanel.add("North", new Label(probLabel));
    plotPanel.add("North", new Label("Santa Fe Trail"));
		
    plot = new XYPlot();
    //plot = new TrailPlot();
    //plot = prob.getGraphics();	
    plotPanel.add("Center", plot);
    
    return plotPanel;
  }
  */

  /*
   public SetUI getTerminalSet() {

		ProgramChoice[] terminalChoices = {
			new ProgramChoice("Left", new Left().getClass()),
			new ProgramChoice("Right", new Right().getClass()),
			new ProgramChoice("Move", new Move().getClass())
		};
		int[] terminalSelections = {0, 1, 2};
		SetUI termSet = new SetUI("Terminal set", terminalChoices, terminalSelections);
		
		return termSet;
  }
  */


  public String getProblemName() {
    return "Artificial Ant following the Santa Fe Trail"; 
  }


  public SetUI getFunctionSet() {

		ProgramChoice[] functionChoices = {
			new ProgramChoice("IF-FOOD-AHEAD", new IfFoodAhead().getClass()),
			new ProgramChoice("PROGN2", new Progn2().getClass()),
			new ProgramChoice("PROGN3", new Progn3().getClass())
		};
		int[] functionSelections = {0, 1, 2};
		SetUI functionSet = new SetUI("Function set", functionChoices, functionSelections);
		
		return functionSet;
		
  }


  //public RealPoint[] fitnessFunction(Individual ind, GP gp) {
  // public void fitnessFunction(Individual ind, GP gp, int individualNr) {
       /**
	* This function has to evaluate the fitness for a specific individual.
	* As a side-effect, it notfies any observers of the GP that an individual
	* has been evaluated and supplies the test cases.
	*/
  /*    
                //double rawFitness = 0.0;
                //Ant.problemName = SantaFe;
                timeSteps = 400;
                foodEaten = 0;
		//ind.hits = 0;
		X = 0;
		Y = 0;
		facing = Ant.EAST;
		
		evalFitness(ind, gp, individualNr, (double)gridSize);
		*/	
		/*
		while (Ant.timeSteps > 0) do {
		  ind.program.eval();  
		}

		ind.adjustedFitness = Ant.foodEaten;
		//ind.standardisedFitness = numFoodPieces - foodEaten;
		ind.hits = Ant.foodEaten;

		if (ind.hits == numFoodPieces) { 
		  maxHits = true; 
		}

		gp.notifyObservers(new GPMessageEvaluatingIndividual(gp.currentGeneration, individualNr, null));
		*/
  // }

  
  //public void evalBestOfRunIndividual(Individual bestIndv, GP gp) {
        /**
	* This function has to evaluate the fitness for a specific individual.
	* As a side-effect, it notfies any observers of the GP that an individual
	* has been evaluated and supplies the test cases.
	*/
  /* 	
		gp.notifyObservers(new GPMessageBestFound(gp.currentGeneration,
					bestIndv.program.toString(0),
					null,
					bestIndv.adjustedFitness));
		
  }
  */

       /**
	* Computes the normalized and adjusted fitness of each
	* individual in the population.
	*/
  /*
	public void normalizeFitnessOfPopulation(Individual[] population) {
	  normalizeFitness(population, numFoodPieces);
	}
	*/
  /*
         for (int i = 0; i < population.length; i++) {
			//	Set the adjusted fitness.
			population[i].standardizedFitness = numFoodPieces - population[i].adjustedFitness ; 
			population[i].normalizedFitness = population[i].adjustedFitness ; 
			//	Add up the adjusted fitnesses so that we can normalize them.
			// sumOfAdjustedFitnesses =
			//		sumOfAdjustedFitnesses + population[i].adjustedFitness;
		}
	}
	*/

  /*
  public void makeDefaultFitnessCases() {

    fitnessCaseString = "Santa Fe Trail --- 89 food pieces";
    fitnessCases = new TrailUI("Fitness cases", fitnessCaseString);
    
    food = new boolean[gridSize][gridSize];
    
    //initialise 2-D grid to false
    for (int i = 0; i <  gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
	food[i][j] = false;
      }
    }
    placeFoodPieces();
    
  }
  */  

  void placeFoodPieces() {

    food[1][0] = true;
    food[2][0] = true;
    food[3][0] = true;
    food[3][1] = true;
    food[3][2] = true;
    food[3][3] = true;
    food[3][4] = true;
    food[3][5] = true;
    food[4][5] = true;
    food[5][5] = true;
    food[6][5] = true;
    food[8][5] = true;
    food[9][5] = true;
    food[10][5] = true;
    food[11][5] = true;
    food[12][5] = true;
    food[12][6] = true;
    food[12][7] = true;
    food[12][8] = true;
    food[12][9] = true;
    food[12][11] = true;
    food[12][12] = true;
    food[12][13] = true;
    food[12][14] = true;
    food[12][17] = true;
    food[12][18] = true;
    food[12][19] = true;
    food[12][20] = true;
    food[12][21] = true;
    food[12][22] = true;
    food[12][23] = true;
    food[11][24] = true;
    food[10][24] = true;
    food[9][24] = true;
    food[8][24] = true;
    food[7][24] = true;
    food[4][24] = true;
    food[3][24] = true;
    food[1][25] = true;
    food[1][26] = true;
    food[1][27] = true;
    food[1][28] = true;
    food[2][30] = true;
    food[3][30] = true;
    food[4][30] = true;
    food[5][30] = true;
    food[7][29] = true;
    food[7][28] = true;
    food[8][27] = true;
    food[9][27] = true;
    food[10][27] = true;
    food[11][27] = true;
    food[12][27] = true;
    food[13][27] = true;
    food[14][27] = true;
    food[16][26] = true;
    food[16][25] = true;
    food[16][24] = true;
    food[16][21] = true;
    food[16][20] = true;
    food[16][19] = true;
    food[16][18] = true;
    food[17][15] = true;
    food[20][14] = true;
    food[20][13] = true;
    food[20][10] = true;
    food[20][9] = true;
    food[20][8] = true;
    food[20][7] = true;
    food[21][5] = true;
    food[22][5] = true;
    food[24][4] = true;
    food[24][3] = true;
    food[25][2] = true;
    food[26][2] = true;
    food[27][2] = true;
    food[29][3] = true;
    food[29][4] = true;
    food[29][6] = true;
    food[29][9] = true;
    food[29][12] = true;
    food[28][14] = true;
    food[27][14] = true;
    food[26][14] = true;
    food[23][15] = true;
    food[24][18] = true;
    food[27][19] = true;
    food[26][22] = true;
    food[23][23] = true;

    // Print grid for verification
    /*
     for (int i=0; i<32; i++) {
      for (int j=0; j<32; j++) {
	System.out.println("Food at " + i + j + " is " + Ant.food[i][j]);
      }
     }
     */
  } 
       

        /**
	* @returns <code>true</code> if the GP algorithm should terminate
	*/
  /*
	public boolean terminationPredicate() {
	  //return currentGeneration >= MAX_GENERATIONS;
	  //return currentGeneration >= maxGenNum.intValue();
	  if (currentGeneration >= maxGenNum.intValue() || maxHits) {
	    return true;
	  }
	}
	*/
  /*
        boolean stopEval() {
	  if (foodEaten == numFoodPieces || timeSteps == 0) {
	    return true;
	  }
	}
	*/
  /*
  static int getNewXCoordinate(int newX) {
    if (newX > gridSize - 1 ) {
      return 0;
    }
    else 
      if (newX < 0) {
      return gridSize - 1;
    }
      else {
	return newX;
      }
  }
      
  static int getNewYCoordinate(int newY) {
    if (newY > gridSize - 1 ) {
      return 0;
    }
    else 
      if (newY < 0) {
      return gridSize - 1;
    }
      else {
	return newY;
      }
  }
  */

  /*
public String getFitnessCaseString() {
  return fitnessCaseString;
}

public PlotUI getFitnessCases() {
  return fitnessCases;
}
*/

  /*
public void setPWindow() {
  System.out.println("Setting window for Santa Fe");
  new Plot().setWindow(0.0, 0.0, 1.0, 89.0);
}
*/
  /*  
public Histogram createHistogram() {
  //System.out.println("Setting window for Santa Fe");
  return new Histogram(0.0, 0.0, 1.0, 89.0);
}
*/

}


















