package bham.cs.fsc.ui;
//package gp.approx.ui;

import java.awt.Canvas;
import java.io.Serializable;

/**
* This is the base class for simple plots.
* It offers methods to set the problem coordinate system
* and the viewport, as well as transformation functions 
* from user coordinates to display units.
*
* @version 1.0
* @author Hans U. Gerber (<a href="mailto:gerber@ifh.ee.ethz.ch">gerber@ifh.ee.ethz.ch</a>)
*/
public abstract class Plot extends Canvas implements Serializable {
	protected double xMin = -0.05;
	protected double yMin = -1.05;
	protected double xMax = +1.05;
	protected double yMax = +1.05;
	private int vLeft =  0;
	private int vTop = 0;
	private int vRight = 100;
	private int vBottom = 100;

	public void setWindow(double xMin, double yMin, double xMax, double yMax) {
		this.xMin = xMin;
		this.xMax = xMax;
		this.yMin = yMin;
		this.yMax = yMax;
		/*
		System.out.println("??? xMin : " + this.xMin);
		System.out.println("??? xMax : " + this.xMax);
		System.out.println("??? yMin : " + this.yMin);
		System.out.println("??? yMax : " + this.yMax);
		*/
	}

	public void setViewport(int vLeft, int vTop, int vRight, int vBottom) {
		this.vLeft = vLeft;
		this.vTop = vTop;
		this.vRight = vRight;
		this.vBottom = vBottom;
		
		/*
		System.out.println("??? vLeft : " + vLeft);
		System.out.println("??? vRight : " + vRight);
		System.out.println("??? vTop : " + vTop);
		System.out.println("??? vBottom : " + vBottom);
		*/
	}

	public int xformX(double x) {
	        /*
		int i = (int)((x - xMin)/(xMax - xMin) * (double)(vRight - vLeft)) + vLeft;
		//return i;
		System.out.println("xformX value is " + i );
		*/
		return (int)((x - xMin)/(xMax - xMin) * (double)(vRight - vLeft)) + vLeft;
	}

	public int xformY(double y) {
	        /*
		int i = (int)((y - yMin)/(yMax - yMin) * (double)(vTop - vBottom)) + vBottom ;
		//return i;
		System.out.println("xformY value is " + i);
		*/
		return (int)((y - yMin)/(yMax - yMin) * (double)(vTop - vBottom)) + vBottom;
	}


// Make abstract so that AntPlot and Approx's UPlot can implement it differently.
  
  public abstract synchronized void setTrace(int which, PlotData[] p);


}



